﻿'*******************************************************************
' Program: Data Center Visio Rack Tool
' Author: Albert E Edlund
' Date:
'
' Purpose:
' Some basic storage for SAN/LUN information
'
'
'*******************************************************************


Imports Microsoft.Practices.EnterpriseLibrary.Common
Imports Microsoft.Practices.EnterpriseLibrary.Data
Imports Microsoft.Practices.EnterpriseLibrary.ExceptionHandling
Imports Microsoft.Practices.EnterpriseLibrary.ExceptionHandling.Logging

Imports System
Imports System.ComponentModel
Imports System.Collections.Generic

Imports System.Collections.ObjectModel


Imports System.Data
Imports System.IO
Imports System.Xml
Imports System.Collections

Imports System.Runtime.InteropServices
Imports Microsoft.Office.Interop.Visio

Imports DC_Rack.Support.clsVisioSupport
Imports DC_Rack.Objects.clsDC_RackData



Public Class clsAttrDiskES



#Region " Properties and definitions "


    Public m_db As Database
    Public m_ds As DataSet
    Public m_dt As DataTable

    Public m_dc As dc_DiskES
    Public m_oc As Collection(Of dc_DiskES)

    Private strUserId As String

    Public m_deleteCommand As DbCommand
    Public m_insertCommand As DbCommand
    Public m_updateCommand As DbCommand


    Private _clsVisio As DC_Rack.Support.clsVisioSupport

    Public Const readAll As String = "selectTblExternalStorage"

    ' who am I
    Private myEnum As DC_RackTables = DC_RackTables.tblAttrExternalStorage

    Private m_visshape As Microsoft.Office.Interop.Visio.Shape
    Public Property _VisShape() As Microsoft.Office.Interop.Visio.Shape
        Get
            Return Me.m_visshape
        End Get
        Set(ByVal value As Microsoft.Office.Interop.Visio.Shape)
            m_visshape = value
        End Set
    End Property

    '********* visio snippet vb.net vis0041vb ******************
    Private _drawingApplication As Microsoft.Office.Interop.Visio.Application
    Public Property drawingApplication() As Microsoft.Office.Interop.Visio.Application
        Get
            Return Me._drawingApplication
        End Get
        Set(ByVal value As Microsoft.Office.Interop.Visio.Application)
            If (value Is Nothing) Then
                Throw New System.ArgumentNullException("ApplicationValueIsNull", _
                    "drawingApplication is Null.")
            End If
            Me._drawingApplication = value
        End Set
    End Property

    '********* visio snippet vb.net vis0043vb ******************
    Private _drawingDocument As Microsoft.Office.Interop.Visio.Document
    Public Property drawingDocument() As Microsoft.Office.Interop.Visio.Document
        Get
            Return Me._drawingDocument
        End Get
        Set(ByVal value As Microsoft.Office.Interop.Visio.Document)
            If (value Is Nothing) Then
                Throw New System.ArgumentNullException("DocumentValueIsNull", _
                    "drawingDocument is Null.")
            End If
            Me._drawingDocument = value
        End Set
    End Property

    '********* visio snippet vb.net vis0045vb ******************
    Private _drawingWindow As Microsoft.Office.Interop.Visio.Window
    Public Property drawingWindow() As Microsoft.Office.Interop.Visio.Window
        Get
            Return Me._drawingWindow
        End Get
        Set(ByVal value As Microsoft.Office.Interop.Visio.Window)
            If (value Is Nothing) Then
                Throw New System.ArgumentNullException("WindowValueIsNull", _
                    "drawingWindow is Null.")
            End If
            Me._drawingWindow = value
        End Set
    End Property

    '********* visio snippet vb.net vis0044vb ******************
    Private _drawingPage As Microsoft.Office.Interop.Visio.Page
    Public Property drawingPage() As Microsoft.Office.Interop.Visio.Page
        Get
            Return Me._drawingPage
        End Get
        Set(ByVal value As Microsoft.Office.Interop.Visio.Page)
            If (value Is Nothing) Then
                Throw New System.ArgumentNullException("PageValueIsNull", _
                    "drawingPage is Null.")
            End If
            Me._drawingPage = value
        End Set
    End Property

    Public m_customstencilpath As String = My.Settings.path_custom_stencils
    Public Property _CustomStencilPath() As String
        Get
            Return Me.m_customstencilpath
        End Get
        Set(ByVal value As String)
            Me.m_customstencilpath = value
        End Set
    End Property


#End Region

#Region " Move/Transform Data "


    '
    ' create columns
    '
    Public Sub CreateTableColumns(ByRef tempTable As DataTable)

        Dim newDC As dc_DiskES = New dc_DiskES(strUserId)

        Try

            Dim colAttrEsKey As New System.Data.DataColumn
            colAttrEsKey.ColumnName = "attresKey"
            colAttrEsKey.DataType = GetType(Int32)
            colAttrEsKey.DefaultValue = m_dc.attresKey
            tempTable.Columns.Add(colAttrEsKey)

            Dim colAttrEsCompKey As New System.Data.DataColumn
            colAttrEsCompKey.ColumnName = "attresCompKey"
            colAttrEsCompKey.DataType = GetType(Int32)
            colAttrEsCompKey.DefaultValue = m_dc.attresCompKey
            tempTable.Columns.Add(colAttrEsCompKey)

            Dim colAttrEsVirtuaHostKey As New System.Data.DataColumn
            colAttrEsVirtuaHostKey.ColumnName = "attresVirtualHostKey"
            colAttrEsVirtuaHostKey.DataType = GetType(Int32)
            colAttrEsVirtuaHostKey.DefaultValue = m_dc.attresVirtualHostKey
            tempTable.Columns.Add(colAttrEsVirtuaHostKey)

            Dim colAttrEsPriNetKey As New System.Data.DataColumn
            colAttrEsPriNetKey.ColumnName = "attresPriNetKey"
            colAttrEsPriNetKey.DataType = GetType(Int32)
            colAttrEsPriNetKey.DefaultValue = m_dc.attresPriNetKey
            tempTable.Columns.Add(colAttrEsPriNetKey)

            Dim colAttrEsRedNetKey As New System.Data.DataColumn
            colAttrEsRedNetKey.ColumnName = "attresRedNetKey"
            colAttrEsRedNetKey.DataType = GetType(Int32)
            colAttrEsRedNetKey.DefaultValue = m_dc.attresRedNetKey
            tempTable.Columns.Add(colAttrEsRedNetKey)

            Dim colAttrEsLUN As New System.Data.DataColumn
            colAttrEsLUN.ColumnName = "attresLUN"
            colAttrEsLUN.DataType = GetType(Integer)
            colAttrEsLUN.DefaultValue = m_dc.attresLUN
            tempTable.Columns.Add(colAttrEsLUN)

            Dim colAttrEsShared As New System.Data.DataColumn
            colAttrEsShared.ColumnName = "attresShared"
            colAttrEsShared.DataType = GetType(String)
            colAttrEsShared.DefaultValue = m_dc.attresShared
            tempTable.Columns.Add(colAttrEsShared)

            Dim colAttrEsPath As New System.Data.DataColumn
            colAttrEsPath.ColumnName = "attresPath"
            colAttrEsPath.DataType = GetType(String)
            colAttrEsPath.DefaultValue = m_dc.attresPath
            tempTable.Columns.Add(colAttrEsPath)

            Dim colAttrEsPerformance As New System.Data.DataColumn
            colAttrEsPerformance.ColumnName = "attresPerformance"
            colAttrEsPerformance.DataType = GetType(String)
            colAttrEsPerformance.DefaultValue = m_dc.attresPerformance
            tempTable.Columns.Add(colAttrEsPerformance)

            Dim colAttrEsSize As New System.Data.DataColumn
            colAttrEsSize.ColumnName = "attresSize"
            colAttrEsSize.DataType = GetType(Integer)
            colAttrEsSize.DefaultValue = m_dc.attresSize
            tempTable.Columns.Add(colAttrEsSize)

            Dim colAttrESComments As New System.Data.DataColumn
            colAttrESComments.ColumnName = "attresComments"
            colAttrESComments.DataType = GetType(String)
            colAttrESComments.DefaultValue = m_dc.attresComments
            tempTable.Columns.Add(colAttrESComments)

            Dim colAttrESLastEdit As New System.Data.DataColumn
            colAttrESLastEdit.ColumnName = "attresLastEdit"
            colAttrESLastEdit.DataType = GetType(String)
            colAttrESLastEdit.DefaultValue = m_dc.attresLastEdit
            tempTable.Columns.Add(colAttrESLastEdit)

            Dim colAttrEsLastUpdate As New System.Data.DataColumn
            colAttrEsLastUpdate.ColumnName = "attresLastUpdate"
            colAttrEsLastUpdate.DataType = GetType(Date)
            colAttrEsLastUpdate.DefaultValue = m_dc.attresLastUpdate
            tempTable.Columns.Add(colAttrEsLastUpdate)

            newDC = Nothing

        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
        Catch ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

        If newDC IsNot Nothing Then
            newDC = Nothing
        End If

    End Sub

    '
    ' use for writing records
    '
    Public Sub movePropertiesToDataRow _
                (ByRef tempRow As DataRow, _
                 ByVal tempDC As dc_DiskES)

        Try

            With tempDC
                tempRow.SetField("attresKey", .attresKey)
                tempRow.SetField("attresCompKey", .attresCompKey)
                tempRow.SetField("attresVirtualHostKey", .attresVirtualHostKey)
                tempRow.SetField("attresPriNetKey", .attresPriNetKey)
                tempRow.SetField("attresRedNetKey", .attresRedNetKey)
                tempRow.SetField("attresLUN", .attresLUN)
                tempRow.SetField("attresShared", .attresShared)
                tempRow.SetField("attresPath", .attresPath)
                tempRow.SetField("attresPerformance", .attresPerformance)
                tempRow.SetField("attresSize", .attresSize)
                tempRow.SetField("attresComments", .attresComments)
                tempRow.SetField("attresLastEdit", .attresLastEdit)
                tempRow.SetField("osLastUpdate", strUserId)
            End With

        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
        Catch ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

    End Sub


    '
    ' for reading records
    '
    Public Sub moveDataRowToProperties _
                (ByVal tempRow As DataRow)

        Try
            With m_dc
                .initProperties()
                .attresKey = tempRow.Item("attresKey")
                .attresCompKey = tempRow.Item("attresCompKey")
                .attresVirtualHostKey = tempRow.Item("attresVirtualHostKey")
                .attresPriNetKey = tempRow.Item("attresPriNetKey")
                .attresRedNetKey = tempRow.Item("attresRedNetKey")
                .attresLUN = tempRow.Item("attresLUN")
                .attresShared = tempRow.Item("attresShared")
                .attresPath = tempRow.Item("attresPath")
                .attresPerformance = tempRow.Item("attresPerformance")
                .attresSize = tempRow.Item("attresSize")
                .attresComments = tempRow.Item("attresComments")
                .attresLastEdit = tempRow.Item("attresLastEdit")
                .attresLastUpdate = tempRow.Item("attresLastUpdate")
            End With

        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
        Catch ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

    End Sub


    '
    ' for reading records
    '
    Public Sub moveDataRowToProperties _
                (ByVal tempRow As DataRow, _
                 ByRef tempDC As dc_DiskES)

        Try
            With tempDC
                .initProperties()
                .attresKey = tempRow.Item("attresKey")
                .attresCompKey = tempRow.Item("attresCompKey")
                .attresVirtualHostKey = tempRow.Item("attresVirtualHostKey")
                .attresPriNetKey = tempRow.Item("attresPriNetKey")
                .attresRedNetKey = tempRow.Item("attresRedNetKey")
                .attresLUN = tempRow.Item("attresLUN")
                .attresShared = tempRow.Item("attresShared")
                .attresPath = tempRow.Item("attresPath")
                .attresPerformance = tempRow.Item("attresPerformance")
                .attresSize = tempRow.Item("attresSize")
                .attresComments = tempRow.Item("attresComments")
                .attresLastEdit = tempRow.Item("attresLastEdit")
                .attresLastUpdate = tempRow.Item("attresLastUpdate")
            End With

        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
        Catch ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

    End Sub

    '
    '
    '
    Public Sub moveDataTableToObservableCollection _
            (ByVal dtTemp As DataTable)

        Try

            If 0 < dtTemp.Rows.Count Then

                If m_oc IsNot Nothing Then
                    m_oc = Nothing
                    m_oc = New Collection(Of dc_DiskES)
                Else
                    m_oc = New Collection(Of dc_DiskES)
                End If

                Dim drTemp As DataRow
                Dim dcTemp As dc_DiskES
                For Each drTemp In dtTemp.Rows
                    dcTemp = New dc_DiskES
                    moveDataRowToProperties(drTemp, dcTemp)
                    m_oc.Add(dcTemp)
                Next

            End If

        Catch ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        End Try



    End Sub


    '
    '
    '
    Public Function moveDataTableToXML() As XmlDocument

        Dim writer = New System.IO.StringWriter
        Dim m_dt_xml As Xml.XmlDocument = Nothing

        Try


            m_dt.WriteXml(writer, XmlWriteMode.WriteSchema, True)
            m_dt_xml = Nothing
            m_dt_xml = New Xml.XmlDocument
            m_dt_xml.LoadXml(writer.ToString)

        Catch ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        Finally

            writer = Nothing

        End Try

        Return m_dt_xml


    End Function

#End Region

#Region " Standard calls "


    '
    '
    '
    Public Sub initDataSetAndTable()

        Try

            ' make sure the root stuff is there
            If m_ds Is Nothing Then
                m_ds = New DataSet
            Else
                m_ds = Nothing
                m_ds = New DataSet
            End If
            m_ds.SchemaSerializationMode = SchemaSerializationMode.IncludeSchema

            If m_dt Is Nothing Then
                m_dt = New DataTable
            Else
                m_dt = Nothing
                m_dt = New DataTable
            End If

            If m_oc Is Nothing Then
                m_oc = New Collection(Of dc_DiskES)
            Else
                m_oc = Nothing
                m_oc = New Collection(Of dc_DiskES)
            End If

            If m_dc IsNot Nothing Then
                m_dc = Nothing
                m_dc = New dc_DiskES(strUserId)
            Else
                m_dc = New dc_DiskES(strUserId)
            End If

            CreateTableColumns(m_dt)
            m_dt.TableName = DC_RackTables.tblAttrExternalStorage.ToString
            m_ds.Tables.Add(m_dt)

        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
        Catch ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

    End Sub


    '
    ' create a record based on property values move it to the generic datatable
    ' then copy the table to the database
    '
    Public Function addAttrEsDataSourceRecord _
        (ByVal tempDC As dc_DiskES, _
         Optional ByVal blnSilent As Boolean = False) _
        As Integer

        Dim intRowsAffected As Integer = 0

        Try

            initDataSetAndTable()

            Dim m_dr As DataRow = m_ds.Tables(DC_RackTables.tblAttrExternalStorage.ToString).NewRow
            movePropertiesToDataRow(m_dr, tempDC)
            m_ds.Tables(DC_RackTables.tblAttrExternalStorage.ToString).Rows.Add(m_dr)
            intRowsAffected = dbUpdateDataSet()


            If blnSilent = False Then
                MsgBox("DataRowsUpated = " & intRowsAffected)
            End If

        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
        Catch ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

        Return intRowsAffected

    End Function

    '
    '
    '
    Private Sub buildInsertESCommand()

        Try
            m_insertCommand = m_db.GetStoredProcCommand("insertAttrExternalStorage")

            Dim cmdActive As DbCommand
            cmdActive = m_insertCommand
            m_db.AddInParameter(cmdActive, "attresCompKey", DbType.Int32, "attresCompKey", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "attresVirtualHostKey", DbType.Int32, "attresVirtualHostKey", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "attresPriNetKey", DbType.Int32, "attresPriNetKey", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "attresRedNetKey", DbType.Int32, "attresPriNetKey", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "attresLUN", DbType.Int16, "attresLUN", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "attresShared", DbType.String, "attresShared", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "attresPath", DbType.String, "attresPath", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "attresPerformance", DbType.String, "attresPerformance", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "attresSize", DbType.Int16, "attresSize", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "attresComments", DbType.String, "attresComments", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "attresLastEdit", DbType.String, "attresLastEdit", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "attresLastUpdate", DbType.Date, "attresLastUpdate", DataRowVersion.Current)


        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

    End Sub

    '
    '
    '
    Private Sub buildUpdateESCommand()

        Try
            m_updateCommand = m_db.GetStoredProcCommand("updateAttrExternalStorage")

            Dim cmdActive As DbCommand
            cmdActive = m_updateCommand
            m_db.AddInParameter(cmdActive, "attresKey", DbType.Int32, "attresKey", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "attresCompKey", DbType.Int32, "attresCompKey", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "attresVirtualHostKey", DbType.Int32, "attresVirtualHostKey", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "attresPriNetKey", DbType.Int32, "attresPriNetKey", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "attresRedNetKey", DbType.Int32, "attresPriNetKey", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "attresLUN", DbType.Int16, "attresLUN", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "attresShared", DbType.String, "attresShared", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "attresPath", DbType.String, "attresPath", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "attresPerformance", DbType.String, "attresPerformance", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "attresSize", DbType.Int16, "attresSize", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "attresComments", DbType.String, "attresComments", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "attresLastEdit", DbType.String, "attresLastEdit", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "attresLastUpdate", DbType.Date, "attresLastUpdate", DataRowVersion.Current)


        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

    End Sub


    '
    '
    '
    Private Sub buildDeleteEsCommand()

        Try
            m_deleteCommand = m_db.GetStoredProcCommand("deleteAttrExternalStorage")

            Dim cmdActive As DbCommand
            cmdActive = m_deleteCommand
            m_db.AddInParameter(cmdActive, "attresKey", DbType.Int32, "attresKey", DataRowVersion.Current)


        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

    End Sub


    '
    '
    '
    Public Function dbUpdateDataSet() As Int16

        Dim rowsAffected As Int16 = 0

        Try

            rowsAffected = m_db.UpdateDataSet(m_ds, DC_RackTables.tblAttrOperatingSystem.ToString, _
                                        m_insertCommand, _
                                        m_updateCommand, _
                                        m_deleteCommand, _
                                        UpdateBehavior.Standard)
            'msgbox rowsAffected

        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If

        End Try

        Return rowsAffected

    End Function


#End Region

#Region " database calls "


    '
    '
    '
    Public Sub dbSelectAllExternalStorage()


        Try


            initDataSetAndTable()

            ' Retrieve the initial data
            Dim cmd As DbCommand = m_db.GetStoredProcCommand(readAll)
            m_db.LoadDataSet(cmd, m_ds, DC_RackTables.tblAttrExternalStorage.ToString)
            m_dt = m_ds.Tables(DC_RackTables.tblAttrExternalStorage.ToString)


        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

    End Sub


    '
    '
    '
    Public Sub dbSelectAttrExternalStorageByRowKey _
            (ByVal lngRowKey As Int32)

        Try

            initDataSetAndTable()

            ' Retrieve the initial data
            Dim cmd As DbCommand = m_db.GetStoredProcCommand("selectAttrExternalStorageByRowKey")
            m_db.AddInParameter(cmd, "@RowKey", DbType.Int32, lngRowKey)
            m_db.LoadDataSet(cmd, m_ds, DC_RackTables.tblAttrExternalStorage.ToString)
            m_dt = m_ds.Tables(DC_RackTables.tblAttrExternalStorage.ToString)


        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
        Catch Ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(Ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

    End Sub

    '
    '
    '
    Public Sub dbSelectAttrExternalStorageByUrriKeys _
            (ByVal colURRIKeys As Collection(Of clsDC_RackData.rackURRI))

        initDataSetAndTable()


        Dim dtInput As DataTable = New DataTable
        Dim dtOutput As DataTable = New DataTable
        Dim drTemp As DataRow
        Dim lngRackKey As Int32
        Dim colRacks As Collection = New Collection
        Dim rckUrri As clsDC_RackData.rackURRI

        For Each rckUrri In colURRIKeys
            colRacks.Add(rckUrri.rckKey)
        Next rckUrri

        Try

            For intX = 1 To colRacks.Count
                lngRackKey = colRacks(intX)
                If Not (dtInput Is Nothing) Then
                    dtInput = Nothing
                    dtInput = New DataTable
                Else
                    dtInput = New DataTable
                End If
                dtInput = GetAttrExternalStorageByRack(lngRackKey)
                With dtInput
                    If intX = 1 Then
                        dtOutput = Nothing
                        dtOutput = New DataTable
                        dtOutput = dtInput.Copy
                    Else
                        For Each drTemp In .Rows
                            dtOutput.ImportRow(drTemp)
                        Next
                    End If
                End With
            Next intX


            For Each drTemp In dtOutput.Rows
                m_ds.Tables(DC_RackTables.tblAttrVirtualHost.ToString).ImportRow(drTemp)
            Next

            m_dt = m_ds.Tables(DC_RackTables.tblAttrVirtualHost.ToString)
            m_dt.TableName = DC_RackTables.tblAttrVirtualHost.ToString

        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
        Catch Ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(Ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

    End Sub

    '
    '
    '
    Public Function GetAttrExternalStorageByRack _
                (ByVal lngRackKey As Int32) _
                As DataTable

        Dim m_dt1 As DataTable = New DataTable
        Dim dtReturn As DataTable = New DataTable
        Dim m_ds1 As DataSet = New DataSet

        Try

            Dim cmd1 As DbCommand
            cmd1 = m_db.GetStoredProcCommand("selectAttrExternalStorageByRack")
            m_db.AddInParameter(cmd1, "@compKey", DbType.Int32, lngRackKey)
            m_db.LoadDataSet(cmd1, m_ds1, "temp")
            m_dt1 = m_ds1.Tables("temp")

        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
            m_dt1 = Nothing
        End Try

        GetAttrExternalStorageByRack = m_dt1

    End Function

    '
    '
    '
    Public Sub dbDeleteESComponentKey(ByVal intCompKey As Int32)


        If intCompKey = -1 Then Exit Sub

        Try

            Dim cmd As DbCommand = m_db.GetStoredProcCommand("deleteESComponentKey")
            m_db.AddInParameter(cmd, "@compKey", DbType.Int32, intCompKey)

            Dim affectedRows As Int16 = m_db.ExecuteNonQuery(cmd)

        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
        End Try


    End Sub

    '
    '
    '
    Public Sub dbSelectAttrExternalStorageByCompKey(ByVal intCompKey As Int32)


        Try


            initDataSetAndTable()

            ' Retrieve the initial data
            Dim cmd As DbCommand = m_db.GetStoredProcCommand("selectAttrExternalStorageByCompKey")
            m_db.AddInParameter(cmd, "@compKey", DbType.Int32, intCompKey)
            m_db.LoadDataSet(cmd, m_ds, DC_RackTables.tblAttrExternalStorage.ToString)

            m_dt = m_ds.Tables(DC_RackTables.tblAttrExternalStorage.ToString)

            If m_dt.Rows.Count = 1 Then
                Dim m_dr As System.Data.DataRow = m_dt.Rows(0)
                moveDataRowToProperties(m_dr)
            End If


        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

    End Sub

    '
    '
    '
    Public Sub dbSelectAttrExternalStorageByVHKey(ByVal intVHKey As Int32)


        Try


            initDataSetAndTable()

            ' Retrieve the initial data
            Dim cmd As DbCommand = m_db.GetStoredProcCommand("selectAttrExternalStorageByVHKey")
            m_db.AddInParameter(cmd, "@VHKey", DbType.Int32, intVHKey)
            m_db.LoadDataSet(cmd, m_ds, DC_RackTables.tblAttrExternalStorage.ToString)

            m_dt = m_ds.Tables(DC_RackTables.tblAttrExternalStorage.ToString)

            If m_dt.Rows.Count = 1 Then
                Dim m_dr As System.Data.DataRow = m_dt.Rows(0)
                moveDataRowToProperties(m_dr)
            End If


        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

    End Sub






#End Region

#Region " constructor "

    '
    '
    '
    Public Sub New(ByVal visApp As Microsoft.Office.Interop.Visio.Application, _
                   ByVal visDoc As Microsoft.Office.Interop.Visio.Document)
        Try


            m_db = DatabaseFactory.CreateDatabase()

            strUserId = Environment.UserDomainName & "/" & Environment.UserName

            '
            ' init an object class so that the default constants are available
            ' to the table definitions
            '


            initDataSetAndTable()

            drawingApplication = visApp
            drawingDocument = visDoc

            _clsVisio = New DC_Rack.Support.clsVisioSupport
            _clsVisio.drawingApplication = visApp
            _clsVisio.drawingDocument = visDoc


            m_updateCommand = Nothing
            m_insertCommand = Nothing
            m_deleteCommand = Nothing

            buildInsertESCommand()
            buildDeleteEsCommand()
            buildUpdateESCommand()


        Catch ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        End Try



    End Sub


#End Region

#Region " Visio Properties "

    '
    '
    '
    Public Sub UpdateExternalStorageProperties _
        (ByRef visShape As Microsoft.Office.Interop.Visio.Shape, _
         ByVal drDiskEs As System.Data.DataRow)


        Try
            With m_dc

                If Not (drDiskEs Is Nothing) Then

                    moveDataRowToProperties(drDiskEs)

                End If


                _clsVisio.ForceShapeData(visShape, "attresKey", CStr(.attresKey), "attrDiskEs")
                _clsVisio.ForceShapeData(visShape, "attresCompKey", CStr(.attresCompKey), "attrDiskEs")
                _clsVisio.ForceShapeData(visShape, "attresVirtualHostKey", CStr(.attresVirtualHostKey), "attrDiskEs")
                _clsVisio.ForceShapeData(visShape, "attresPriNetKey", CStr(.attresPriNetKey), "attrDiskEs")
                _clsVisio.ForceShapeData(visShape, "attresRedNetKey", CStr(.attresRedNetKey), "attrDiskEs")
                _clsVisio.ForceShapeData(visShape, "attresLUN", CStr(.attresLUN), "attrDiskEs")
                _clsVisio.ForceShapeData(visShape, "attresShared", .attresShared, "attrDiskEs")
                _clsVisio.ForceShapeData(visShape, "attresPath", .attresPath, "attrDiskEs")
                _clsVisio.ForceShapeData(visShape, "attresSize", CStr(.attresSize), "attrDiskEs")
                _clsVisio.ForceShapeData(visShape, "attresPerformance", .attresPerformance, "attrDiskEs")

            End With


        Catch com As COMException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(com, "Com+ Policy")
            If (rethrow) Then
                Throw
            End If
        Catch ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

    End Sub



    Private Const constDiskESPinX As String = "4 in"
    Private Const constDiskESPinY As String = "5 in"
    Private Const constDiskESAlign As VisListAlignment = VisListAlignment.visListAlignLeftOrTop
    Private Const constDiskESDir As VisListDirection = VisListDirection.visListDirTopToBottom
    Private Const constDiskESHeader As String = "External Storage"
    Private Const constDiskESMaster As String = "Container 4"

    '
    '
    '
    Public Function buildComponentDiskESContainer _
                        (ByVal intCompKey As Int32, _
                       ByVal _clsData As clsDC_RackData) _
                        As Microsoft.Office.Interop.Visio.Shape

        Dim shpContainer As Microsoft.Office.Interop.Visio.Shape = Nothing

        ' just to make sure
        _clsVisio.drawingPage = drawingPage
        drawingDocument = drawingPage.Document

        Try


            Dim colInput As Collection = New Collection
            Dim drTemp As System.Data.DataRow = Nothing
            Dim diskesQuery = From diskes In _clsData.m_ds.Tables(DC_RackTables.tblAttrExternalStorage.ToString).AsEnumerable() _
                       Where diskes!attresCompKey = intCompKey
                      Select diskes

            If diskesQuery.Count = 0 Then Return shpContainer

            For Each des In diskesQuery
                colInput.Add("attresKey_" & des.Item("attresKey").ToString)
                'System.Diagnostics.Debug.WriteLine(des.Item("attresPath").ToString)
                'System.Diagnostics.Debug.WriteLine(des.Item("attresKey").ToString)
            Next des

            ' create a list control
            Dim listControl As Microsoft.Office.Interop.Visio.Shape = Nothing
            Dim colMembers As Collection = New Collection

            Dim strStencil As String = ""
            Dim strMaster As String = ""
            Dim strDGMaster As String = ""
            Dim visDG As Microsoft.Office.Interop.Visio.Master = Nothing
            Dim intLabelFont As Integer
            Dim intValueFont As Integer
            Dim dblCalloutWidth As Double
            Dim dgmasterQuery = From datagraphic In _clsData.m_ds.Tables(DC_RackTables.tblDGMasters.ToString).AsEnumerable() _
                                Where datagraphic!dgmTable = DC_RackTables.tblAttrExternalStorage.ToString _
                                Select datagraphic

            ' should only be one..
            For Each m In dgmasterQuery
                If LCase(m!dgmTable) = LCase(DC_RackTables.tblAttrExternalStorage.ToString) Then
                    strStencil = m!dgmSurrogateStencil
                    strStencil = _CustomStencilPath & strStencil
                    strMaster = m!dgmSurrogateMaster
                    intLabelFont = CInt(m!dgmFontLabel)
                    intValueFont = CInt(m!dgmFontValue)
                    dblCalloutWidth = CDbl(m!dgmCalloutWidth)
                    strDGMaster = m!dgmMaster
                    Exit For
                End If
            Next

            ' pass in the created collection and return a populated list control
            colMembers = _clsVisio.dropDropDownBoxItems(colInput, strMaster, strStencil, , , vbTrue)

            Dim visShape As Microsoft.Office.Interop.Visio.Shape = Nothing
            Dim visCell As Microsoft.Office.Interop.Visio.Cell = Nothing

            Dim strName As String = ""
            Dim strKey As String = ""

            For Each shapeId In colMembers
                ' get the shape
                visShape = drawingPage.Shapes.ItemFromID(shapeId)
                If visShape.CellExists("user.attrkey", False) = True Then
                    strName = visShape.Cells("user.attrkey").ResultStr("")
                Else
                    strName = ""
                    GoTo NextShape
                End If

                ' clear any shape data properties
                _clsVisio.deleteShapeData(visShape)

                ' set it semi-transparent
                Dim strTrans As String = "50%"
                ' first the fill properties
                _clsVisio.recurseApplyCellFormula(visShape, VisSectionIndices.visSectionObject, VisRowIndices.visRowFill, VisCellIndices.visFillForegndTrans, strTrans)
                _clsVisio.recurseApplyCellFormula(visShape, VisSectionIndices.visSectionObject, VisRowIndices.visRowFill, VisCellIndices.visFillBkgndTrans, strTrans)
                ' then the line properties
                _clsVisio.recurseApplyCellFormula(visShape, VisSectionIndices.visSectionObject, VisRowIndices.visRowLine, VisCellIndices.visLineColorTrans, strTrans)
                ' prep it for applying the datagraphics by applying the data from the dgmasters table
                _clsVisio.addDataGraphicUserFieldsToShape _
                        (visShape, _
                        intValueFont.ToString, _
                        intLabelFont.ToString, _
                        dblCalloutWidth.ToString)

                'Check that the requested Data Graphic Master exits
                For Each visMaster In drawingDocument.Masters
                    If visMaster.Type = VisMasterTypes.visTypeDataGraphic Then
                        If visMaster.Name = strDGMaster Then
                            visDG = visMaster
                            Exit For
                        End If
                    End If
                Next

                ' go read the current records
                For Each des In diskesQuery
                    strKey = "attresKey_" & des.Item("attresKey").ToString
                    If strKey = strName Then
                        UpdateExternalStorageProperties(visShape, des)
                        visShape.Text = des.Item("attresPath").ToString

                        ' allow the legend to keep track of the shapes
                        _clsVisio.ForceUserProperty(visShape, "visLegendShape", "2.0")

                        ' move the external storage disk deviceid to comment field so we get mouse over
                        If visShape.CellsSRCExists(VisSectionIndices.visSectionObject, VisRowIndices.visRowMisc, VisCellIndices.visComment, False) = True Then
                            visCell = visShape.CellsSRC(VisSectionIndices.visSectionObject, VisRowIndices.visRowMisc, VisCellIndices.visComment)
                            _clsVisio.SetCellValueToString(visCell, strName)
                        End If

                        'Apply the Data Graphic to the Shape
                        visShape.DataGraphic = visDG

                        ' unlock the groups so we can change the font sizes
                        _clsVisio.recurseApplyCellFormula(visShape, VisSectionIndices.visSectionObject, VisRowIndices.visRowLock, VisCellIndices.visLockGroup, "0")

                        If visShape.CellExists("user.dbIntLabelFont", False) = True Then

                            ' get the loaded values 
                            intLabelFont = CInt(visShape.Cells("user.dbintlabelfont").ResultIU)
                            intValueFont = CInt(visShape.Cells("user.dbintvaluefont").ResultIU)
                            dblCalloutWidth = CDbl(visShape.Cells("user.dbdblcallout").ResultIU)

                            ' set the callout width = 85% of the surrogate shapes width (as a formula) so that it fits inside the shape
                            Dim strId As String = visShape.NameID & "!Width*.85"
                            strId = "Guard(" & strId & ")"

                            _clsVisio.recurseApplyCustomFormula(visShape, "prop.msvcalloutproplabelsize", intLabelFont.ToString & " pt")
                            _clsVisio.recurseApplyCustomFormula(visShape, "prop.msvcalloutpropvaluesize", intValueFont.ToString & " pt")
                            _clsVisio.recurseApplyCustomFormula(visShape, "prop.msvcalloutpropwidth", strId)

                        End If


                        Exit For
                    End If
                Next des
NextShape:
            Next shapeId

            shpContainer = _clsVisio.addContainerToPage(constDiskESMaster, "contDiskExternal", "")

            listControl = _clsVisio.loadListControl(colMembers, constDiskESAlign, constDiskESDir)
            listControl.Name = "listDiskES"
            listControl.NameU = "listDiskES"

            ' add the list control to the container
            _clsVisio.AddShapeToContainer(shpContainer, listControl)

            shpContainer.Cells("pinx").Formula = constDiskESPinX
            shpContainer.Cells("piny").Formula = constDiskESPinY



        Catch com As COMException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(com, "Com+ Policy")
            If (rethrow) Then
                Throw
            End If
        Catch ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

        System.Windows.Forms.Application.DoEvents()
        Return shpContainer

    End Function



#End Region




End Class
