﻿'*******************************************************************
' Program: Data Center Visio Rack Tool
' Author: Albert E Edlund
' Date:
'
' Purpose:
'
'
'
'*******************************************************************


Imports Microsoft.Practices.EnterpriseLibrary.Common
Imports Microsoft.Practices.EnterpriseLibrary.Data
Imports Microsoft.Practices.EnterpriseLibrary.ExceptionHandling
Imports Microsoft.Practices.EnterpriseLibrary.ExceptionHandling.Logging


Imports System
Imports System.ComponentModel
Imports System.Collections
Imports System.Collections.Generic
Imports System.Collections.ObjectModel

Imports System.Data
Imports System.IO
Imports System.Xml

Imports System.Runtime.InteropServices
Imports Microsoft.Office.Interop.Visio



Imports DC_Rack.Support.clsVisioSupport
Imports DC_Rack.Objects.clsDC_RackData




Public Class clsAttrDiskLogical

#Region " Properties and definitions "

    Public m_db As Database
    Public m_ds As DataSet
    Public m_dt As DataTable

    Public m_dc As dc_DiskLogical
    Public m_oc As Collection(Of dc_DiskLogical)

    Private strUserId As String

    Public m_deleteCommand As DbCommand
    Public m_insertCommand As DbCommand
    Public m_updateCommand As DbCommand


    Public _clsVisio As DC_Rack.Support.clsVisioSupport
    Public m_datagraphicmaster As String

    Public Const readAll As String = "selectTblDiskLogical"

    ' who am I
    Private myEnum As DC_RackTables = DC_RackTables.tblAttrDiskLogical


    '********* visio snippet vb.net vis0041vb ******************
    Private _drawingApplication As Microsoft.Office.Interop.Visio.Application
    Public Property drawingApplication() As Microsoft.Office.Interop.Visio.Application
        Get
            Return Me._drawingApplication
        End Get
        Set(ByVal value As Microsoft.Office.Interop.Visio.Application)
            If (value Is Nothing) Then
                Throw New System.ArgumentNullException("ApplicationValueIsNull", _
                    "drawingApplication is Null.")
            End If
            Me._drawingApplication = value
        End Set
    End Property

    '********* visio snippet vb.net vis0043vb ******************
    Private _drawingDocument As Microsoft.Office.Interop.Visio.Document
    Public Property drawingDocument() As Microsoft.Office.Interop.Visio.Document
        Get
            Return Me._drawingDocument
        End Get
        Set(ByVal value As Microsoft.Office.Interop.Visio.Document)
            If (value Is Nothing) Then
                Throw New System.ArgumentNullException("DocumentValueIsNull", _
                    "drawingDocument is Null.")
            End If
            Me._drawingDocument = value
        End Set
    End Property

    '********* visio snippet vb.net vis0045vb ******************
    Private _drawingWindow As Microsoft.Office.Interop.Visio.Window
    Public Property drawingWindow() As Microsoft.Office.Interop.Visio.Window
        Get
            Return Me._drawingWindow
        End Get
        Set(ByVal value As Microsoft.Office.Interop.Visio.Window)
            If (value Is Nothing) Then
                Throw New System.ArgumentNullException("WindowValueIsNull", _
                    "drawingWindow is Null.")
            End If
            Me._drawingWindow = value
        End Set
    End Property

    '********* visio snippet vb.net vis0044vb ******************
    Private _drawingPage As Microsoft.Office.Interop.Visio.Page
    Public Property drawingPage() As Microsoft.Office.Interop.Visio.Page
        Get
            Return Me._drawingPage
        End Get
        Set(ByVal value As Microsoft.Office.Interop.Visio.Page)
            If (value Is Nothing) Then
                Throw New System.ArgumentNullException("PageValueIsNull", _
                    "drawingPage is Null.")
            End If
            Me._drawingPage = value
        End Set
    End Property

    Public m_customstencilpath As String = My.Settings.path_custom_stencils
    Public Property _CustomStencilPath() As String
        Get
            Return Me.m_customstencilpath
        End Get
        Set(ByVal value As String)
            Me.m_customstencilpath = value
        End Set
    End Property


#End Region

#Region " Move/Transform Data "


    '
    ' create columns
    '
    Public Sub CreateTableColumns(ByRef tempTable As DataTable)

        Dim newDC As dc_DiskLogical = New dc_DiskLogical(strUserId)

        Try

            Dim collogicalDiskKey As New System.Data.DataColumn
            collogicalDiskKey.ColumnName = "logicalDiskKey"
            collogicalDiskKey.DataType = GetType(Integer)
            collogicalDiskKey.DefaultValue = m_dc.logicalDiskKey
            tempTable.Columns.Add(collogicalDiskKey)

            Dim collogicalDiskCompKey As New System.Data.DataColumn
            collogicalDiskCompKey.ColumnName = "logicalDiskCompKey"
            collogicalDiskCompKey.DataType = GetType(Integer)
            collogicalDiskCompKey.DefaultValue = m_dc.logicalDiskCompKey
            tempTable.Columns.Add(collogicalDiskCompKey)

            Dim collogicalDiskVirtualHostKey As New System.Data.DataColumn
            collogicalDiskVirtualHostKey.ColumnName = "logicalDiskVirtualHostKey"
            collogicalDiskVirtualHostKey.DataType = GetType(Integer)
            collogicalDiskVirtualHostKey.DefaultValue = m_dc.logicalDiskVirtualHostKey
            tempTable.Columns.Add(collogicalDiskVirtualHostKey)

            Dim collogicalDiskDeviceId As New System.Data.DataColumn
            collogicalDiskDeviceId.ColumnName = "logicalDiskDeviceId"
            collogicalDiskDeviceId.DataType = GetType(String)
            collogicalDiskDeviceId.DefaultValue = m_dc.logicalDiskDeviceId
            tempTable.Columns.Add(collogicalDiskDeviceId)

            Dim collogicalDiskDescription As New System.Data.DataColumn
            collogicalDiskDescription.ColumnName = "logicalDiskDescription"
            collogicalDiskDescription.DataType = GetType(String)
            collogicalDiskDescription.DefaultValue = m_dc.logicalDiskDescription
            tempTable.Columns.Add(collogicalDiskDescription)

            Dim collogicalDiskDeviceType As New System.Data.DataColumn
            collogicalDiskDeviceType.ColumnName = "logicalDiskDeviceType"
            collogicalDiskDeviceType.DataType = GetType(Integer)
            collogicalDiskDeviceType.DefaultValue = m_dc.logicalDiskDeviceType
            tempTable.Columns.Add(collogicalDiskDeviceType)

            Dim collogicalDiskFileSystem As New System.Data.DataColumn
            collogicalDiskFileSystem.ColumnName = "logicalDiskFileSystem"
            collogicalDiskFileSystem.DataType = GetType(String)
            collogicalDiskFileSystem.DefaultValue = m_dc.logicalDiskFileSystem
            tempTable.Columns.Add(collogicalDiskFileSystem)

            Dim collogicalDiskFreeSpace As New System.Data.DataColumn
            collogicalDiskFreeSpace.ColumnName = "logicalDiskFreeSpace"
            collogicalDiskFreeSpace.DataType = GetType(Int64)
            collogicalDiskFreeSpace.DefaultValue = m_dc.logicalDiskFreeSpace
            tempTable.Columns.Add(collogicalDiskFreeSpace)

            Dim collogicalDiskSize As New System.Data.DataColumn
            collogicalDiskSize.ColumnName = "logicalDiskSize"
            collogicalDiskSize.DataType = GetType(Int64)
            collogicalDiskSize.DefaultValue = m_dc.logicalDiskSize
            tempTable.Columns.Add(collogicalDiskSize)

            Dim collogicalDiskVolumeName As New System.Data.DataColumn
            collogicalDiskVolumeName.ColumnName = "logicalDiskVolumeName"
            collogicalDiskVolumeName.DataType = GetType(String)
            collogicalDiskVolumeName.DefaultValue = m_dc.logicalDiskVolumeName
            tempTable.Columns.Add(collogicalDiskVolumeName)

            Dim collogicalDiskVolumeSerial As New System.Data.DataColumn
            collogicalDiskVolumeSerial.ColumnName = "logicalDiskVolumeSerial"
            collogicalDiskVolumeSerial.DataType = GetType(String)
            collogicalDiskVolumeSerial.DefaultValue = m_dc.logicalDiskVolumeSerial
            tempTable.Columns.Add(collogicalDiskVolumeSerial)

            Dim collogicalDiskComments As New System.Data.DataColumn
            collogicalDiskComments.ColumnName = "logicalDiskComment"
            collogicalDiskComments.DataType = GetType(String)
            collogicalDiskComments.DefaultValue = m_dc.logicalDiskComment
            tempTable.Columns.Add(collogicalDiskComments)

            Dim collogicalDiskLastUpdate As New System.Data.DataColumn
            collogicalDiskLastUpdate.ColumnName = "logicalDiskLastUpdate"
            collogicalDiskLastUpdate.DataType = GetType(Date)
            collogicalDiskLastUpdate.DefaultValue = m_dc.logicalDiskLastUpdate
            tempTable.Columns.Add(collogicalDiskLastUpdate)

            Dim collogicalDiskLastEdit As New System.Data.DataColumn
            collogicalDiskLastEdit.ColumnName = "logicalDiskLastEdit"
            collogicalDiskLastEdit.DataType = GetType(String)
            collogicalDiskLastEdit.DefaultValue = m_dc.logicalDiskLastEdit
            tempTable.Columns.Add(collogicalDiskLastEdit)

            newDC = Nothing

        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
        Catch ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

        If newDC IsNot Nothing Then
            newDC = Nothing
        End If

    End Sub


    '
    ' use for writing records
    '
    Public Sub movePropertiesToDataRow _
        (ByRef tempRow As DataRow, _
         ByVal tempDC As dc_DiskLogical)

        Try
            With tempDC
                tempRow.SetField("logicalDiskKey", .logicalDiskKey)
                tempRow.SetField("logicalDiskCompKey", .logicalDiskCompKey)
                tempRow.SetField("logicalDiskVirtualHostKey", .logicalDiskVirtualHostKey)
                tempRow.SetField("logicalDiskDeviceId", .logicalDiskDeviceId)
                tempRow.SetField("logicalDiskDescription", .logicalDiskDescription)
                tempRow.SetField("logicalDiskDeviceType", .logicalDiskDeviceType)
                tempRow.SetField("logicalDiskFileSystem", .logicalDiskFileSystem)
                tempRow.SetField("logicalDiskFreeSpace", .logicalDiskFreeSpace)
                tempRow.SetField("logicalDiskSize", .logicalDiskSize)
                tempRow.SetField("logicalDiskVolumeName", .logicalDiskVolumeName)
                tempRow.SetField("logicalDiskVolumeSerial", .logicalDiskVolumeSerial)
                tempRow.SetField("logicalDiskKey", .logicalDiskKey)
                tempRow.SetField("logicalDiskComment", .logicalDiskComment)
                tempRow.SetField("logicalDiskLastUpdate", .logicalDiskLastUpdate)
                tempRow.SetField("logicalDiskLastEdit", strUserId)
            End With



        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
        Catch ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

    End Sub

    '
    ' for reading records
    '
    Public Sub moveDataRowToProperties _
                (ByVal tempRow As DataRow)

        Try
            With m_dc
                .initProperties()
                .logicalDiskKey = tempRow.Item("logicalDiskKey")
                .logicalDiskCompKey = tempRow.Item("logicalDiskCompKey")
                .logicalDiskVirtualHostKey = tempRow.Item("logicalDiskVirtualHostKey")
                .logicalDiskDeviceId = tempRow.Item("logicalDiskDeviceId")
                .logicalDiskDescription = tempRow.Item("logicalDiskDescription")
                .logicalDiskDeviceType = tempRow.Item("logicalDiskDeviceType")
                .logicalDiskFileSystem = tempRow.Item("logicalDiskFileSystem")
                .logicalDiskFreeSpace = tempRow.Item("logicalDiskFreeSpace")
                .logicalDiskSize = tempRow.Item("logicalDiskSize")
                .logicalDiskVolumeName = tempRow.Item("logicalDiskVolumeName")
                .logicalDiskVolumeSerial = tempRow.Item("logicalDiskVolumeSerial")
                .logicalDiskKey = tempRow.Item("logicalDiskKey")
                .logicalDiskComment = tempRow.Item("logicalDiskComment")
                .logicalDiskLastUpdate = tempRow.Item("logicalDiskLastUpdate")
                .logicalDiskLastEdit = tempRow.Item("logicalDiskLastEdit")
            End With


        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
        Catch ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

    End Sub


    '
    ' for reading records
    '
    Public Sub moveDataRowToProperties _
                (ByVal tempRow As DataRow, _
                 ByRef tempDC As dc_DiskLogical)

        Try
            With tempDC
                .initProperties()
                .logicalDiskKey = tempRow.Item("logicalDiskKey")
                .logicalDiskCompKey = tempRow.Item("logicalDiskCompKey")
                .logicalDiskVirtualHostKey = tempRow.Item("logicalDiskVirtualHostKey")
                .logicalDiskDeviceId = tempRow.Item("logicalDiskDeviceId")
                .logicalDiskDescription = tempRow.Item("logicalDiskDescription")
                .logicalDiskDeviceType = tempRow.Item("logicalDiskDeviceType")
                .logicalDiskFileSystem = tempRow.Item("logicalDiskFileSystem")
                .logicalDiskFreeSpace = tempRow.Item("logicalDiskFreeSpace")
                .logicalDiskSize = tempRow.Item("logicalDiskSize")
                .logicalDiskVolumeName = tempRow.Item("logicalDiskVolumeName")
                .logicalDiskVolumeSerial = tempRow.Item("logicalDiskVolumeSerial")
                .logicalDiskKey = tempRow.Item("logicalDiskKey")
                .logicalDiskComment = tempRow.Item("logicalDiskComment")
                .logicalDiskLastUpdate = tempRow.Item("logicalDiskLastUpdate")
                .logicalDiskLastEdit = tempRow.Item("logicalDiskLastEdit")
            End With


        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
        Catch ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

    End Sub


    '
    '
    '
    Public Sub moveDataTableToObservableCollection _
            (ByVal dtTemp As DataTable)

        Try

            If 0 < dtTemp.Rows.Count Then

                If m_oc IsNot Nothing Then
                    m_oc = Nothing
                    m_oc = New Collection(Of dc_DiskLogical)
                Else
                    m_oc = New Collection(Of dc_DiskLogical)
                End If

                Dim drTemp As DataRow
                Dim dcTemp As dc_DiskLogical
                For Each drTemp In dtTemp.Rows
                    dcTemp = New dc_DiskLogical
                    moveDataRowToProperties(drTemp, dcTemp)
                    m_oc.Add(dcTemp)
                Next

            End If

        Catch ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        End Try



    End Sub


    '
    '
    '
    Public Function moveDataTableToXML() As XmlDocument

        Dim writer = New System.IO.StringWriter
        Dim m_dt_xml As Xml.XmlDocument = Nothing

        Try


            m_dt.WriteXml(writer, XmlWriteMode.WriteSchema, True)
            m_dt_xml = Nothing
            m_dt_xml = New Xml.XmlDocument
            m_dt_xml.LoadXml(writer.ToString)

        Catch ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        Finally

            writer = Nothing

        End Try

        Return m_dt_xml


    End Function


#End Region

#Region " Standard Calls "


    '
    ' take the existing Table and put it back into the database
    ' with any changes that may have occured
    '
    Public Function dbUpdateDataSet() As Int16

        Dim rowsAffected As Int16 = 0

        Try

            rowsAffected = m_db.UpdateDataSet(m_ds, DC_RackTables.tblAttrDiskLogical.ToString, _
                                        m_insertCommand, _
                                        m_updateCommand, _
                                        m_deleteCommand, _
                                        UpdateBehavior.Standard)
            'msgbox rowsAffected

        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If

        End Try

        Return rowsAffected

    End Function

    '
    '
    '
    Private Sub buildInsertAttrLogicalDiskCommand()



        Try
            m_insertCommand = m_db.GetStoredProcCommand("insertAttrDiskLogical")

            Dim cmdActive As DbCommand
            cmdActive = m_insertCommand

            m_db.AddInParameter(cmdActive, "logicalDiskCompKey", DbType.Int32, "logicalDiskCompKey", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "logicalDiskVirtualHostKey", DbType.Int32, "logicalDiskVirtualHostKey", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "logicalDiskDeviceId", DbType.String, "logicalDiskDeviceId", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "logicalDiskDescription", DbType.String, "logicalDiskDescription", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "logicalDiskDeviceType", DbType.Int32, "logicalDiskDeviceType", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "logicalDiskFileSystem", DbType.String, "logicalDiskFileSystem", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "logicalDiskFreeSpace", DbType.Int64, "logicalDiskFreeSpace", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "logicalDiskSize", DbType.Int64, "logicalDiskSize", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "logicalDiskVolumeName", DbType.String, "logicalDiskVolumeName", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "logicalDiskVolumeSerial", DbType.String, "logicalDiskVolumeSerial", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "logicalDiskComment", DbType.String, "logicalDiskComment", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "logicalDiskLastUpdate", DbType.Date, "logicalDiskLastUpdate", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "logicalDiskLastEdit", DbType.String, "logicalDiskLastEdit", DataRowVersion.Current)


        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

    End Sub

    '
    '
    '
    Private Sub buildDeleteAttrLogicalDiskCommand()

        Try
            m_deleteCommand = m_db.GetStoredProcCommand("deleteAttrDiskLogical")

            Dim cmdActive As DbCommand
            cmdActive = m_deleteCommand

            m_db.AddInParameter(cmdActive, "logicalDiskKey", DbType.Int32, "logicalDiskKey", DataRowVersion.Current)

        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
        End Try
    End Sub

    '
    '
    '
    Private Sub buildUpdateAttrLogicalDiskCommand()


        Try
            m_updateCommand = m_db.GetStoredProcCommand("updateAttrDiskLogical")

            Dim cmdActive As DbCommand
            cmdActive = m_updateCommand

            m_db.AddInParameter(cmdActive, "logicalDiskKey", DbType.Int32, "logicalDiskKey", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "logicalDiskCompKey", DbType.Int32, "logicalDiskCompKey", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "logicalDiskVirtualHostKey", DbType.Int32, "logicalDiskVirtualHostKey", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "logicalDiskDeviceId", DbType.String, "logicalDiskDeviceId", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "logicalDiskDescription", DbType.String, "logicalDiskDescription", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "logicalDiskDeviceType", DbType.Int32, "logicalDiskDeviceType", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "logicalDiskFileSystem", DbType.String, "logicalDiskFileSystem", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "logicalDiskFreeSpace", DbType.Int64, "logicalDiskFreeSpace", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "logicalDiskSize", DbType.Int64, "logicalDiskSize", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "logicalDiskVolumeName", DbType.String, "logicalDiskVolumeName", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "logicalDiskVolumeSerial", DbType.String, "logicalDiskVolumeSerial", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "logicalDiskComment", DbType.String, "logicalDiskComment", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "logicalDiskLastUpdate", DbType.Date, "logicalDiskLastUpdate", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "logicalDiskLastEdit", DbType.String, "logicalDiskLastEdit", DataRowVersion.Current)

        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
        End Try



    End Sub

    '
    ' create a record based on property values move it to the generic datatable
    ' then copy the table to the database
    '
    Public Function addAttrDiskLogicalDataSourceRecord _
        (ByVal tempDC As dc_DiskLogical, _
         Optional ByVal blnSilent As Boolean = False) _
        As Integer

        Dim intRowsAffected As Integer = 0

        Try

            initDataSetAndTable()

            Dim m_dr As DataRow = m_ds.Tables(DC_RackTables.tblAttrDiskLogical.ToString).NewRow
            movePropertiesToDataRow(m_dr, tempDC)
            m_ds.Tables(DC_RackTables.tblAttrDiskLogical.ToString).Rows.Add(m_dr)
            intRowsAffected = dbUpdateDataSet()


            If blnSilent = False Then
                MsgBox("DataRowsUpated = " & intRowsAffected)
            End If

        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
        Catch ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

        Return intRowsAffected

    End Function

    '
    '
    '
    Public Sub initDataSetAndTable()

        Try

            ' make sure the root stuff is there
            If m_ds Is Nothing Then
                m_ds = New DataSet
            Else
                m_ds = Nothing
                m_ds = New DataSet
            End If
            m_ds.SchemaSerializationMode = SchemaSerializationMode.IncludeSchema

            If m_dt Is Nothing Then
                m_dt = New DataTable
            Else
                m_dt = Nothing
                m_dt = New DataTable
            End If

            If m_oc Is Nothing Then
                m_oc = New Collection(Of dc_DiskLogical)
            Else
                m_oc = Nothing
                m_oc = New Collection(Of dc_DiskLogical)
            End If

            If m_dc Is Nothing Then
                m_dc = New dc_DiskLogical(strUserId)
            Else
                m_dc = Nothing
                m_dc = New dc_DiskLogical(strUserId)
            End If

            CreateTableColumns(m_dt)
            m_dt.TableName = DC_RackTables.tblAttrDiskLogical.ToString
            m_ds.Tables.Add(m_dt)

        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
        Catch ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        End Try



    End Sub



#End Region

#Region " database calls "


    '
    '
    '
    Public Sub dbSelectAllDiskLogical()


        Try

            If m_dc IsNot Nothing Then
                m_dc = Nothing
                m_dc = New dc_DiskLogical

            Else
                m_dc = New dc_DiskLogical

            End If

            initDataSetAndTable()

            ' Retrieve the initial data
            Dim cmd As DbCommand = m_db.GetStoredProcCommand(readAll)
            m_db.LoadDataSet(cmd, m_ds, DC_RackTables.tblAttrDiskLogical.ToString)

            m_dt = m_ds.Tables(DC_RackTables.tblAttrDiskLogical.ToString)


        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

    End Sub


    '
    '
    '
    Public Sub dbSelectAttrDiskLogicalByCompKey(ByVal intCompKey As Int32)


        Try


            initDataSetAndTable()

            ' Retrieve the initial data
            Dim cmd As DbCommand = m_db.GetStoredProcCommand("selectAttrDiskLogicalByCompKey")
            m_db.AddInParameter(cmd, "@compKey", DbType.Int32, intCompKey)
            m_db.LoadDataSet(cmd, m_ds, DC_RackTables.tblAttrDiskLogical.ToString)

            m_dt = m_ds.Tables(DC_RackTables.tblAttrDiskLogical.ToString)

            If m_dt.Rows.Count = 1 Then
                Dim m_dr As System.Data.DataRow = m_dt.Rows(0)
                moveDataRowToProperties(m_dr)
            End If


        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

    End Sub

    '
    '
    '
    Public Sub dbSelectAttrDiskLogicalByVHKey(ByVal intVHKey As Int32)


        Try


            initDataSetAndTable()

            ' Retrieve the initial data
            Dim cmd As DbCommand = m_db.GetStoredProcCommand("selectAttrDiskLogicalByVHKey")
            m_db.AddInParameter(cmd, "@VHKey", DbType.Int32, intVHKey)
            m_db.LoadDataSet(cmd, m_ds, DC_RackTables.tblAttrDiskLogical.ToString)

            m_dt = m_ds.Tables(DC_RackTables.tblAttrDiskLogical.ToString)

            If m_dt.Rows.Count = 1 Then
                Dim m_dr As System.Data.DataRow = m_dt.Rows(0)
                moveDataRowToProperties(m_dr)
            End If


        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

    End Sub


    '
    '
    '
    Public Sub dbSelectAttrDiskLogicalByRowKey _
            (ByVal lngRowKey As Int32)

        Try

            initDataSetAndTable()

            ' Retrieve the initial data
            Dim cmd As DbCommand = m_db.GetStoredProcCommand("selectAttrDiskLogicalByRowKey")
            m_db.AddInParameter(cmd, "@RowKey", DbType.Int32, lngRowKey)
            m_db.LoadDataSet(cmd, m_ds, DC_RackTables.tblAttrDiskLogical.ToString)
            m_dt = m_ds.Tables(DC_RackTables.tblAttrDiskLogical.ToString)


        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
        Catch Ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(Ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

    End Sub


    '
    '
    '
    Public Sub dbSelectAttrDiskLogicalByUrriKeys _
            (ByVal colURRIKeys As Collection(Of clsDC_RackData.rackURRI))

        initDataSetAndTable()


        Dim dtInput As DataTable = New DataTable
        Dim dtOutput As DataTable = New DataTable
        Dim drTemp As DataRow
        Dim lngRackKey As Int32
        Dim colRacks As Collection = New Collection
        Dim rckUrri As clsDC_RackData.rackURRI

        For Each rckURRI In colURRIKeys
            colRacks.Add(rckUrri.rckKey)
        Next rckURRI

        Try

            For intX = 1 To colRacks.Count
                lngRackKey = colRacks(intX)
                If Not (dtInput Is Nothing) Then
                    dtInput = Nothing
                    dtInput = New DataTable
                Else
                    dtInput = New DataTable
                End If
                dtInput = GetAttrDiskLogicalByRack(lngRackKey)
                With dtInput
                    If intX = 1 Then
                        dtOutput = Nothing
                        dtOutput = New DataTable
                        dtOutput = dtInput.Copy
                    Else
                        For Each drTemp In .Rows
                            dtOutput.ImportRow(drTemp)
                        Next
                    End If
                End With
            Next intX

            For Each drTemp In dtOutput.Rows
                m_ds.Tables(DC_RackTables.tblAttrDiskLogical.ToString).ImportRow(drTemp)
            Next

            m_dt = m_ds.Tables(DC_RackTables.tblAttrDiskLogical.ToString)
            m_dt.TableName = DC_RackTables.tblAttrDiskLogical.ToString

        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
        Catch Ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(Ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

    End Sub

    '
    '
    '
    Public Function GetAttrDiskLogicalByRack _
                (ByVal lngRackKey As Int32) _
                As DataTable

        Dim m_dt1 As DataTable = New DataTable
        Dim dtReturn As DataTable = New DataTable
        Dim m_ds1 As DataSet = New DataSet

        Try

            Dim cmd1 As DbCommand
            cmd1 = m_db.GetStoredProcCommand("selectAttrDiskLogicalByRack")
            m_db.AddInParameter(cmd1, "@compKey", DbType.Int32, lngRackKey)
            m_db.LoadDataSet(cmd1, m_ds1, "temp")
            m_dt1 = m_ds1.Tables("temp")

        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
            m_dt1 = Nothing
        End Try

        GetAttrDiskLogicalByRack = m_dt1

    End Function


#End Region

#Region " Constructor "

    '
    '
    '
    Public Sub New(ByVal visApp As Microsoft.Office.Interop.Visio.Application, _
                   ByVal visDoc As Microsoft.Office.Interop.Visio.Document)
        Try


            m_db = DatabaseFactory.CreateDatabase()
            strUserId = Environment.UserDomainName & "/" & Environment.UserName

            '
            ' init an object class so that the default constants are available
            ' to the table definitions
            '

            If m_dc IsNot Nothing Then
                m_dc = Nothing
                m_dc = New dc_DiskLogical(strUserId)
            Else
                m_dc = New dc_DiskLogical(strUserId)
            End If

            initDataSetAndTable()


            _clsVisio = New DC_Rack.Support.clsVisioSupport
            _clsVisio.drawingApplication = visApp
            _clsVisio.drawingDocument = visDoc

            m_updateCommand = Nothing
            m_insertCommand = Nothing
            m_deleteCommand = Nothing

            buildInsertAttrLogicalDiskCommand()
            buildDeleteAttrLogicalDiskCommand()
            buildUpdateAttrLogicalDiskCommand()


        Catch ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

    End Sub

#End Region


#Region " Visio Properties "

    '
    '
    '
    Public Sub UpdateDiskLogicalProperties _
        (ByRef visShape As Microsoft.Office.Interop.Visio.Shape, _
         ByVal drDiskL As System.Data.DataRow)



        Try
            With m_dc

                If Not (drDiskL Is Nothing) Then

                    moveDataRowToProperties(drDiskL)

                End If


                _clsVisio.ForceShapeData(visShape, "logicalDiskKey", CStr(.logicalDiskKey), "attrDiskL")
                _clsVisio.ForceShapeData(visShape, "logicalDiskCompKey", CStr(.logicalDiskCompKey), "attrDiskL")
                _clsVisio.ForceShapeData(visShape, "logicalDiskVirtualHostKey", CStr(.logicalDiskVirtualHostKey), "attrDiskL")
                _clsVisio.ForceShapeData(visShape, "logicalDiskDeviceId", .logicalDiskDeviceId, "attrDiskL")
                _clsVisio.ForceShapeData(visShape, "logicalDiskDescription", .logicalDiskDescription, "attrDiskL")
                _clsVisio.ForceShapeData(visShape, "logicalDiskDeviceType", CStr(.logicalDiskDeviceType), "attrDiskL")
                _clsVisio.ForceShapeData(visShape, "logicalDiskFileSystem", .logicalDiskFileSystem, "attrDiskL")
                _clsVisio.ForceShapeData(visShape, "logicalDiskFreeSpace", CStr(.logicalDiskFreeSpace), "attrDiskL")
                _clsVisio.ForceShapeData(visShape, "logicalDiskSize", CStr(.logicalDiskSize), "attrDiskL")
                _clsVisio.ForceShapeData(visShape, "logicalDiskVolumeName", .logicalDiskVolumeName, "attrDiskL")
                _clsVisio.ForceShapeData(visShape, "logicalDiskVolumeSerial", .logicalDiskVolumeSerial, "attrDiskL")


            End With


        Catch com As COMException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(com, "Com+ Policy")
            If (rethrow) Then
                Throw
            End If
        Catch ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

    End Sub



    Private Const constDiskLPinX As String = "4 in"
    Private Const constDiskLPinY As String = "6.5 in"
    Private Const constDiskLAlign As VisListAlignment = VisListAlignment.visListAlignLeftOrTop
    Private Const constDiskLDir As VisListDirection = VisListDirection.visListDirTopToBottom
    Private Const constDiskLHeader As String = "Logical Disks (Partitions)"
    Private Const constDiskLMaster As String = "Container 4"

    '
    '
    '
    Public Function buildComponentDiskLogicalContainer _
                        (ByVal intCompKey As Int32, _
                       ByVal _clsData As clsDC_RackData) _
                        As Microsoft.Office.Interop.Visio.Shape

        Dim shpContainer As Microsoft.Office.Interop.Visio.Shape = Nothing

        ' just to make sure
        _clsVisio.drawingPage = drawingPage
        drawingDocument = drawingPage.Document

        Try


            Dim colInput As Collection = New Collection
            Dim drTemp As System.Data.DataRow = Nothing
            Dim disklQuery = From disklogical In _clsData.m_ds.Tables(DC_RackTables.tblAttrDiskLogical.ToString).AsEnumerable() _
                       Where disklogical!logicaldiskCompKey = intCompKey
                      Select disklogical

            If disklQuery.Count = Nothing Then Return shpContainer


            For Each dl In disklQuery
                colInput.Add("logicalDiskKey_" & dl.Item("logicalDiskKey").ToString)
            Next dl

            ' create a list control
            Dim listControl As Microsoft.Office.Interop.Visio.Shape = Nothing
            Dim colMembers As Collection = New Collection

            Dim strStencil As String = ""
            Dim strMaster As String = ""
            Dim strDGMaster As String = ""
            Dim visDG As Microsoft.Office.Interop.Visio.Master = Nothing
            Dim intLabelFont As Integer
            Dim intValueFont As Integer
            Dim dblCalloutWidth As Double
            Dim dgmasterQuery = From datagraphic In _clsData.m_ds.Tables(DC_RackTables.tblDGMasters.ToString).AsEnumerable() _
                                Where datagraphic!dgmTable = DC_RackTables.tblAttrDiskLogical.ToString _
                                Select datagraphic

            ' should only be one..
            For Each m In dgmasterQuery
                If LCase(m!dgmTable) = LCase(DC_RackTables.tblAttrDiskLogical.ToString) Then
                    strStencil = m!dgmSurrogateStencil
                    strStencil = _CustomStencilPath & strStencil
                    strMaster = m!dgmSurrogateMaster
                    intLabelFont = CInt(m!dgmFontLabel)
                    intValueFont = CInt(m!dgmFontValue)
                    dblCalloutWidth = CDbl(m!dgmCalloutWidth)
                    strDGMaster = m!dgmMaster
                    Exit For
                End If
            Next

            ' pass in the created collection and return a populated list control
            colMembers = _clsVisio.dropDropDownBoxItems(colInput, strMaster, strStencil, , , vbTrue)

            Dim visShape As Microsoft.Office.Interop.Visio.Shape = Nothing
            Dim visCell As Microsoft.Office.Interop.Visio.Cell = Nothing

            Dim strName As String = ""
            Dim strKey As String = ""

            For Each shapeId In colMembers
                ' get the shape
                visShape = drawingPage.Shapes.ItemFromID(shapeId)

                If visShape.CellExists("user.attrkey", False) = True Then
                    strName = visShape.Cells("user.attrkey").ResultStr("")
                Else
                    strName = ""
                    GoTo NextShape
                End If

                ' clear any shape data properties
                _clsVisio.deleteShapeData(visShape)

                ' set it semi-transparent
                Dim strTrans As String = "50%"
                ' first the fill properties
                _clsVisio.recurseApplyCellFormula(visShape, VisSectionIndices.visSectionObject, VisRowIndices.visRowFill, VisCellIndices.visFillForegndTrans, strTrans)
                _clsVisio.recurseApplyCellFormula(visShape, VisSectionIndices.visSectionObject, VisRowIndices.visRowFill, VisCellIndices.visFillBkgndTrans, strTrans)
                ' then the line properties
                _clsVisio.recurseApplyCellFormula(visShape, VisSectionIndices.visSectionObject, VisRowIndices.visRowLine, VisCellIndices.visLineColorTrans, strTrans)
                ' prep it for applying the datagraphics by applying the data from the dgmasters table
                _clsVisio.addDataGraphicUserFieldsToShape _
                        (visShape, _
                        intValueFont.ToString, _
                        intLabelFont.ToString, _
                        dblCalloutWidth.ToString)

                'Check that the requested Data Graphic Master exits
                For Each visMaster In drawingDocument.Masters
                    If visMaster.Type = VisMasterTypes.visTypeDataGraphic Then
                        If visMaster.Name = strDGMaster Then
                            visDG = visMaster
                            Exit For
                        End If
                    End If
                Next

                ' go read the current records
                For Each dl In disklQuery
                    strKey = "logicalDiskKey_" & dl.Item("logicalDiskKey").ToString
                    If strKey = strName Then
                        UpdateDiskLogicalProperties(visShape, dl)
                        visShape.Text = dl.Item("logicalDiskDeviceId").ToString

                        ' allow the legend to keep track of the shapes
                        _clsVisio.ForceUserProperty(visShape, "visLegendShape", "2.0")

                        ' move the name to comment field so we get mouse over
                        If visShape.CellsSRCExists(VisSectionIndices.visSectionObject, VisRowIndices.visRowMisc, VisCellIndices.visComment, False) = True Then
                            visCell = visShape.CellsSRC(VisSectionIndices.visSectionObject, VisRowIndices.visRowMisc, VisCellIndices.visComment)
                            _clsVisio.SetCellValueToString(visCell, strName)
                        End If

                        'Apply the Data Graphic to the Shape
                        visShape.DataGraphic = visDG

                        ' unlock the groups so we can change the font sizes
                        _clsVisio.recurseApplyCellFormula(visShape, VisSectionIndices.visSectionObject, VisRowIndices.visRowLock, VisCellIndices.visLockGroup, "0")

                        If visShape.CellExists("user.dbIntLabelFont", False) = True Then

                            ' get the loaded values 
                            intLabelFont = CInt(visShape.Cells("user.dbintlabelfont").ResultIU)
                            intValueFont = CInt(visShape.Cells("user.dbintvaluefont").ResultIU)
                            dblCalloutWidth = CDbl(visShape.Cells("user.dbdblcallout").ResultIU)

                            ' set the callout width = 85% of the surrogate shapes width (as a formula) so that it fits inside the shape
                            Dim strId As String = visShape.NameID & "!Width*.85"
                            strId = "Guard(" & strId & ")"

                            _clsVisio.recurseApplyCustomFormula(visShape, "prop.msvcalloutproplabelsize", intLabelFont.ToString & " pt")
                            _clsVisio.recurseApplyCustomFormula(visShape, "prop.msvcalloutpropvaluesize", intValueFont.ToString & " pt")
                            _clsVisio.recurseApplyCustomFormula(visShape, "prop.msvcalloutpropwidth", strId)

                        End If

                        Exit For
                    End If
                Next dl
NextShape:

            Next shapeId


            shpContainer = _clsVisio.addContainerToPage(constDiskLMaster, "contDiskLogical", "")

            listControl = _clsVisio.loadListControl(colMembers, constDiskLAlign, constDiskLDir)
            listControl.Name = "listDiskL"
            listControl.NameU = "listDiskL"

            ' add the list control to the container
            _clsVisio.AddShapeToContainer(shpContainer, listControl)

            shpContainer.Cells("pinx").Formula = constDiskLPinX
            shpContainer.Cells("piny").Formula = constDiskLPinY

        Catch com As COMException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(com, "Com+ Policy")
            If (rethrow) Then
                Throw
            End If
        Catch ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        End Try
        System.Windows.Forms.Application.DoEvents()
        Return shpContainer

    End Function


#End Region



End Class
