﻿'*******************************************************************
' Program: Data Center Visio Rack Tool
' Author: Albert E Edlund
' Date:
'
' Purpose:
'
'
'
'*******************************************************************


Imports Microsoft.Practices.EnterpriseLibrary.Common
Imports Microsoft.Practices.EnterpriseLibrary.Data
Imports Microsoft.Practices.EnterpriseLibrary.ExceptionHandling
Imports Microsoft.Practices.EnterpriseLibrary.ExceptionHandling.Logging


Imports System
Imports System.ComponentModel
Imports System.Collections.Generic
Imports System.Collections.ObjectModel


Imports System.Data
Imports System.IO
Imports System.Xml
Imports System.Collections

Imports System.Runtime.InteropServices
Imports Microsoft.Office.Interop.Visio

Imports DC_Rack.Support.clsVisioSupport
Imports DC_Rack.Objects.clsDC_RackData
Imports DC_Rack.Objects.dc_Component


Public Class clsAttrProcessor


#Region "Properties and definitions"

    Public m_db As Database
    Public m_ds As DataSet
    Public m_dt As DataTable

    Public m_dc As dc_Processor
    Public m_oc As Collection(Of dc_Processor)

    Private strUserId As String

    Public m_deleteCommand As DbCommand
    Public m_insertCommand As DbCommand
    Public m_updateCommand As DbCommand


    Public _clsVisio As DC_Rack.Support.clsVisioSupport
    Public m_datagraphicmaster As String

    Public Const readAll As String = "selectTblProcessor"

    ' who am I
    Private myEnum As DC_RackTables = DC_RackTables.tblAttrProcessor

    '********* visio snippet vb.net vis0041vb ******************
    Private _drawingApplication As Microsoft.Office.Interop.Visio.Application
    Public Property drawingApplication() As Microsoft.Office.Interop.Visio.Application
        Get
            Return Me._drawingApplication
        End Get
        Set(ByVal value As Microsoft.Office.Interop.Visio.Application)
            If (value Is Nothing) Then
                Throw New System.ArgumentNullException("ApplicationValueIsNull", _
                    "drawingApplication is Null.")
            End If
            Me._drawingApplication = value
        End Set
    End Property

    '********* visio snippet vb.net vis0043vb ******************
    Private _drawingDocument As Microsoft.Office.Interop.Visio.Document
    Public Property drawingDocument() As Microsoft.Office.Interop.Visio.Document
        Get
            Return Me._drawingDocument
        End Get
        Set(ByVal value As Microsoft.Office.Interop.Visio.Document)
            If (value Is Nothing) Then
                Throw New System.ArgumentNullException("DocumentValueIsNull", _
                    "drawingDocument is Null.")
            End If
            Me._drawingDocument = value
        End Set
    End Property

    '********* visio snippet vb.net vis0045vb ******************
    Private _drawingWindow As Microsoft.Office.Interop.Visio.Window
    Public Property drawingWindow() As Microsoft.Office.Interop.Visio.Window
        Get
            Return Me._drawingWindow
        End Get
        Set(ByVal value As Microsoft.Office.Interop.Visio.Window)
            If (value Is Nothing) Then
                Throw New System.ArgumentNullException("WindowValueIsNull", _
                    "drawingWindow is Null.")
            End If
            Me._drawingWindow = value
        End Set
    End Property

    '********* visio snippet vb.net vis0044vb ******************
    Private _drawingPage As Microsoft.Office.Interop.Visio.Page
    Public Property drawingPage() As Microsoft.Office.Interop.Visio.Page
        Get
            Return Me._drawingPage
        End Get
        Set(ByVal value As Microsoft.Office.Interop.Visio.Page)
            If (value Is Nothing) Then
                Throw New System.ArgumentNullException("PageValueIsNull", _
                    "drawingPage is Null.")
            End If
            Me._drawingPage = value
        End Set
    End Property

    Public m_customstencilpath As String = My.Settings.path_custom_stencils
    Public Property _CustomStencilPath() As String
        Get
            Return Me.m_customstencilpath
        End Get
        Set(ByVal value As String)
            Me.m_customstencilpath = value
        End Set
    End Property

#End Region

#Region " Move/Transform Data "

    '
    ' create columns
    '
    Public Sub CreateTableColumns(ByRef tempTable As DataTable)

        Dim newDC As dc_Processor = New dc_Processor(strUserId)

        Try

            Dim colphysProcKey As New System.Data.DataColumn
            colphysProcKey.ColumnName = "physProcKey"
            colphysProcKey.DataType = GetType(Integer)
            colphysProcKey.DefaultValue = newDC.physProcKey
            tempTable.Columns.Add(colphysProcKey)

            Dim colphysProcCompKey As New System.Data.DataColumn
            colphysProcCompKey.ColumnName = "physProcCompKey"
            colphysProcCompKey.DataType = GetType(Integer)
            colphysProcCompKey.DefaultValue = newDC.physProcCompKey
            tempTable.Columns.Add(colphysProcCompKey)

            Dim colphysProcName As New System.Data.DataColumn
            colphysProcName.ColumnName = "physProcName"
            colphysProcName.DataType = GetType(String)
            colphysProcName.DefaultValue = newDC.physProcName
            tempTable.Columns.Add(colphysProcName)

            Dim colphysProcCores As New System.Data.DataColumn
            colphysProcCores.ColumnName = "physProcCores"
            colphysProcCores.DataType = GetType(Integer)
            colphysProcCores.DefaultValue = newDC.physProcCores
            tempTable.Columns.Add(colphysProcCores)

            Dim colphysProcCoreSpeed As New System.Data.DataColumn
            colphysProcCoreSpeed.ColumnName = "physProcCoreSpeed"
            colphysProcCoreSpeed.DataType = GetType(Long)
            colphysProcCoreSpeed.DefaultValue = newDC.physProcCoreSpeed
            tempTable.Columns.Add(colphysProcCoreSpeed)

            Dim colphysProcDataWidth As New System.Data.DataColumn
            colphysProcDataWidth.ColumnName = "physProcDataWidth"
            colphysProcDataWidth.DataType = GetType(Integer)
            colphysProcDataWidth.DefaultValue = newDC.physProcDataWidth
            tempTable.Columns.Add(colphysProcDataWidth)

            Dim colphysProcAddrWidth As New System.Data.DataColumn
            colphysProcAddrWidth.ColumnName = "physProcAddrWidth"
            colphysProcAddrWidth.DataType = GetType(Integer)
            colphysProcAddrWidth.DefaultValue = newDC.physProcAddrWidth
            tempTable.Columns.Add(colphysProcAddrWidth)

            Dim colphysProcMemSize As New System.Data.DataColumn
            colphysProcMemSize.ColumnName = "physProcMemSize"
            colphysProcMemSize.DataType = GetType(Long)
            colphysProcMemSize.DefaultValue = newDC.physProcMemSize
            tempTable.Columns.Add(colphysProcMemSize)

            Dim colphysProcComments As New System.Data.DataColumn
            colphysProcComments.ColumnName = "physProcComment"
            colphysProcComments.DataType = GetType(String)
            colphysProcComments.DefaultValue = newDC.physProcComment
            tempTable.Columns.Add(colphysProcComments)

            Dim colphysProcLastUpdate As New System.Data.DataColumn
            colphysProcLastUpdate.ColumnName = "physProcLastUpdate"
            colphysProcLastUpdate.DataType = GetType(Date)
            colphysProcLastUpdate.DefaultValue = newDC.physProcLastUpdate
            tempTable.Columns.Add(colphysProcLastUpdate)

            Dim colphysProcLastEdit As New System.Data.DataColumn
            colphysProcLastEdit.ColumnName = "physProcLastEdit"
            colphysProcLastEdit.DataType = GetType(String)
            colphysProcLastEdit.DefaultValue = newDC.physProcLastEdit
            tempTable.Columns.Add(colphysProcLastEdit)

            newDC = Nothing

        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
        Catch ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

        If newDC IsNot Nothing Then
            newDC = Nothing
        End If

    End Sub

    '
    ' use for writing records
    '
    Public Sub movePropertiesToDataRow _
            (ByRef tempRow As DataRow, _
             ByVal tempDC As dc_Processor)

        Try
            With tempDC
                tempRow.SetField("physProcKey", .physProcKey)
                tempRow.SetField("physProcCompKey", .physProcCompKey)
                tempRow.SetField("physProcName", .physProcName)
                tempRow.SetField("physProcCores", .physProcCores)
                tempRow.SetField("physProcCoreSpeed", .physProcCoreSpeed)
                tempRow.SetField("physProcDataWidth", .physProcDataWidth)
                tempRow.SetField("physProcAddrWidth", .physProcAddrWidth)
                tempRow.SetField("physProcMemSize", .physProcMemSize)
                tempRow.SetField("physProcComment", .physProcComment)
                tempRow.SetField("physProcLastUpdate", .physProcLastUpdate)
                tempRow.SetField("physProcLastEdit", .physProcLastEdit)
            End With




        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
        Catch ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

    End Sub

    '
    ' for reading records
    '
    Public Sub moveDataRowToProperties _
                (ByVal tempRow As DataRow)

        Try

            With m_dc
                .initProperties()
                .physProcKey = tempRow.Item("physProcKey")
                .physProcCompKey = tempRow.Item("physProcCompKey")
                .physProcName = tempRow.Item("physProcName")
                .physProcCores = tempRow.Item("physProcCores")
                .physProcCoreSpeed = tempRow.Item("physProcCoreSpeed")
                .physProcDataWidth = tempRow.Item("physProcDataWidth")
                .physProcAddrWidth = tempRow.Item("physProcAddrWidth")
                .physProcMemSize = tempRow.Item("physProcMemSize")
                .physProcComment = tempRow.Item("physProcComment")
                .physProcLastUpdate = tempRow.Item("physProcLastUpdate")
                .physProcLastEdit = tempRow.Item("physProcLastEdit")
            End With

        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
        Catch ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

    End Sub

    '
    ' for reading records
    '
    Public Sub moveDataRowToProperties _
                (ByVal tempRow As DataRow, _
                 ByRef tempDC As dc_Processor)

        Try

            With tempDC
                .initProperties()
                .physProcKey = tempRow.Item("physProcKey")
                .physProcCompKey = tempRow.Item("physProcCompKey")
                .physProcName = tempRow.Item("physProcName")
                .physProcCores = tempRow.Item("physProcCores")
                .physProcCoreSpeed = tempRow.Item("physProcCoreSpeed")
                .physProcDataWidth = tempRow.Item("physProcDataWidth")
                .physProcAddrWidth = tempRow.Item("physProcAddrWidth")
                .physProcMemSize = tempRow.Item("physProcMemSize")
                .physProcComment = tempRow.Item("physProcComment")
                .physProcLastUpdate = tempRow.Item("physProcLastUpdate")
                .physProcLastEdit = tempRow.Item("physProcLastEdit")
            End With

        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
        Catch ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

    End Sub

    '
    '
    '
    Public Sub moveDataTableToObservableCollection _
            (ByVal dtTemp As DataTable)

        Try

            If 0 < dtTemp.Rows.Count Then

                If m_oc IsNot Nothing Then
                    m_oc = Nothing
                    m_oc = New Collection(Of dc_Processor)
                Else
                    m_oc = New Collection(Of dc_Processor)
                End If

                Dim drTemp As DataRow
                Dim dcTemp As dc_Processor
                For Each drTemp In dtTemp.Rows
                    dcTemp = New dc_Processor
                    moveDataRowToProperties(drTemp, dcTemp)
                    m_oc.Add(dcTemp)
                Next

            End If

        Catch ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

    End Sub

    '
    '
    '
    Public Function moveDataTableToXML() As XmlDocument

        Dim writer = New System.IO.StringWriter
        Dim m_dt_xml As Xml.XmlDocument = Nothing

        Try


            m_dt.WriteXml(writer, XmlWriteMode.WriteSchema, True)
            m_dt_xml = Nothing
            m_dt_xml = New Xml.XmlDocument
            m_dt_xml.LoadXml(writer.ToString)

        Catch ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        Finally

            writer = Nothing

        End Try

        Return m_dt_xml


    End Function


#End Region

#Region " Standard Calls "

    '
    '
    '
    Public Sub initDataSetAndTable()

        Try

            ' make sure the root stuff is there
            If m_ds Is Nothing Then
                m_ds = New DataSet
            Else
                m_ds = Nothing
                m_ds = New DataSet
            End If
            m_ds.SchemaSerializationMode = SchemaSerializationMode.IncludeSchema

            If m_dt Is Nothing Then
                m_dt = New DataTable
            Else
                m_dt = Nothing
                m_dt = New DataTable
            End If

            If m_oc Is Nothing Then
                m_oc = New Collection(Of dc_Processor)
            Else
                m_oc = Nothing
                m_oc = New Collection(Of dc_Processor)
            End If

            If m_dc Is Nothing Then
                m_dc = New dc_Processor(strUserId)
            Else
                m_dc = Nothing
                m_dc = New dc_Processor(strUserId)
            End If

            CreateTableColumns(m_dt)
            m_dt.TableName = dc_racktables.tblattrProcessor.tostring
            m_ds.Tables.Add(m_dt)

        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
        Catch ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        End Try



    End Sub

    '
    ' take the existing Table and put it back into the database
    ' with any changes that may have occured
    '
    Public Function dbUpdateDataSet() As Int16

        Dim rowsAffected As Int16 = 0

        Try

            rowsAffected = m_db.UpdateDataSet(m_ds, dc_racktables.tblattrProcessor.tostring, _
                                        m_insertCommand, _
                                        m_updateCommand, _
                                        m_deleteCommand, _
                                        UpdateBehavior.Standard)
            'msgbox rowsAffected

        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If

        End Try

        Return rowsAffected

    End Function

    '
    '
    '
    Private Sub buildInsertAttrPhysProcCommand()



        Try
            m_insertCommand = m_db.GetStoredProcCommand("insertAttrProcessor")

            Dim cmdActive As DbCommand
            cmdActive = m_insertCommand

            m_db.AddInParameter(cmdActive, "physProcCompKey", DbType.Int32, "physProcCompKey", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "physProcName", DbType.String, "physProcName", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "physProcCores", DbType.Int16, "physProcCores", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "physProcCoreSpeed", DbType.Double, "physProcCoreSpeed", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "physProcDataWidth", DbType.Int16, "physProcDataWidth", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "physProcAddrWidth", DbType.Int16, "physProcAddrWidth", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "physProcMemSize", DbType.Int64, "physProcMemSize", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "physProcComment", DbType.String, "physProcComment", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "physProcLastUpdate", DbType.Date, "physProcLastUpdate", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "physProcLastEdit", DbType.String, "physProcLastEdit", DataRowVersion.Current)


        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

    End Sub

    '
    '
    '
    Private Sub buildDeleteAttrPhysProcCommand()

        Try
            m_deleteCommand = m_db.GetStoredProcCommand("deleteAttrProcessor")

            Dim cmdActive As DbCommand
            cmdActive = m_deleteCommand

            m_db.AddInParameter(cmdActive, "physProcKey", DbType.Int32, "physProcKey", DataRowVersion.Current)


        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
        End Try
    End Sub

    '
    '
    '
    Private Sub buildUpdateAttrPhysProcCommand()


        Try
            m_updateCommand = m_db.GetStoredProcCommand("updateAttrProcessor")

            Dim cmdActive As DbCommand
            cmdActive = m_updateCommand

            m_db.AddInParameter(cmdActive, "physProcKey", DbType.Int32, "physProcKey", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "physProcCompKey", DbType.Int32, "physProcCompKey", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "physProcName", DbType.String, "physProcName", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "physProcCores", DbType.Int16, "physProcCores", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "physProcCoreSpeed", DbType.Double, "physProcCoreSpeed", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "physProcDataWidth", DbType.Int16, "physProcDataWidth", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "physProcAddrWidth", DbType.Int16, "physProcAddrWidth", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "physProcMemSize", DbType.Int64, "physProcMemSize", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "physProcComment", DbType.String, "physProcComment", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "physProcLastUpdate", DbType.Date, "physProcLastUpdate", DataRowVersion.Current)
            m_db.AddInParameter(cmdActive, "physProcLastEdit", DbType.String, "physProcLastEdit", DataRowVersion.Current)




        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
        End Try



    End Sub



    '
    ' create a record based on property values move it to the generic datatable
    ' then copy the table to the database
    '
    Public Function addAttrProcessorDataSourceRecord _
        (ByVal tempDC As dc_Processor, _
         Optional ByVal blnSilent As Boolean = False) _
        As Integer

        Dim intRowsAffected As Integer = 0

        Try

            initDataSetAndTable()

            Dim m_dr As DataRow = m_ds.Tables(dc_racktables.tblattrProcessor.tostring).NewRow
            movePropertiesToDataRow(m_dr, tempDC)
            m_ds.Tables(dc_racktables.tblattrProcessor.tostring).Rows.Add(m_dr)
            intRowsAffected = dbUpdateDataSet()


            If blnSilent = False Then
                MsgBox("DataRowsUpated = " & intRowsAffected)
            End If

        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
        Catch ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

        Return intRowsAffected

    End Function


#End Region

#Region " database calls "

    '
    '
    '
    Public Sub dbSelectAllProcessor()


        Try


            initDataSetAndTable()

            ' Retrieve the initial data
            Dim cmd As DbCommand = m_db.GetStoredProcCommand(readAll)
            m_db.LoadDataSet(cmd, m_ds, dc_racktables.tblattrProcessor.tostring)

            m_dt = m_ds.Tables(dc_racktables.tblattrProcessor.tostring)


        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
        Catch ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

    End Sub

    '
    '
    '
    Public Sub dbSelectAttrProcessorByCompKey(ByVal intCompKey As Int32)


        Try


            initDataSetAndTable()

            ' Retrieve the initial data
            Dim cmd As DbCommand = m_db.GetStoredProcCommand("selectAttrProcessorByCompKey")
            m_db.AddInParameter(cmd, "@compKey", DbType.Int32, intCompKey)
            m_db.LoadDataSet(cmd, m_ds, dc_racktables.tblattrProcessor.tostring)

            m_dt = m_ds.Tables(dc_racktables.tblattrProcessor.tostring)

            If m_dt.Rows.Count = 1 Then
                Dim m_dr As System.Data.DataRow = m_dt.Rows(0)
                moveDataRowToProperties(m_dr)
            End If


        Catch sql As SqlException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(sql, "Database Policy")
            If (rethrow) Then
                Throw
            End If
        Catch ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

    End Sub



#End Region

#Region " constructor "

    '
    '
    '
    Public Sub New(ByVal visApp As Microsoft.Office.Interop.Visio.Application, _
                   ByVal visDoc As Microsoft.Office.Interop.Visio.Document)

        Try


            m_db = DatabaseFactory.CreateDatabase()
            strUserId = Environment.UserDomainName & "/" & Environment.UserName

            '
            ' init an object class so that the default constants are available
            ' to the table definitions
            '

            If m_dc IsNot Nothing Then
                m_dc = Nothing
                m_dc = New dc_Processor(strUserId)
            Else
                m_dc = New dc_Processor(strUserId)
            End If

            initDataSetAndTable()

            _drawingApplication = visApp
            _drawingDocument = visDoc


            _clsVisio = New DC_Rack.Support.clsVisioSupport
            _clsVisio.drawingApplication = visApp
            _clsVisio.drawingDocument = visDoc

            m_updateCommand = Nothing
            m_insertCommand = Nothing
            m_deleteCommand = Nothing

            buildInsertAttrPhysProcCommand()
            buildDeleteAttrPhysProcCommand()
            buildUpdateAttrPhysProcCommand()


        Catch ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

    End Sub

#End Region

#Region " Visio Properties "

    '
    '
    '
    Public Sub UpdateProcessorProperties _
        (ByRef visShape As Microsoft.Office.Interop.Visio.Shape, _
         ByVal drProc As System.Data.DataRow)



        Try
            With m_dc

                If Not (drProc Is Nothing) Then

                    moveDataRowToProperties(drProc)

                End If


                _clsVisio.ForceShapeData(visShape, "physProcKey", CStr(.physProcKey), "attrProcessor")
                _clsVisio.ForceShapeData(visShape, "physProcCompKey", CStr(.physProcCompKey), "attrProcessor")
                _clsVisio.ForceShapeData(visShape, "physProcName", .physProcName, "attrProcessor")
                _clsVisio.ForceShapeData(visShape, "physProcCores", CStr(.physProcCores), "attrProcessor")
                _clsVisio.ForceShapeData(visShape, "physProcCoreSpeed", CStr(.physProcCoreSpeed), "attrProcessor")
                _clsVisio.ForceShapeData(visShape, "physProcDataWidth", CStr(.physProcDataWidth), "attrProcessor")
                _clsVisio.ForceShapeData(visShape, "physProcAddrWidth", CStr(.physProcAddrWidth), "attrProcessor")
                _clsVisio.ForceShapeData(visShape, "physProcMemSize", CStr(.physProcMemSize), "attrProcessor")

            End With


        Catch com As COMException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(com, "Com+ Policy")
            If (rethrow) Then
                Throw
            End If
        Catch ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

    End Sub

    Private Const constProcPinX As String = "1.5 in"
    Private Const constProcPinY As String = "8 in"
    Private Const constProcAlign As VisListAlignment = VisListAlignment.visListAlignLeftOrTop
    Private Const constProcDir As VisListDirection = VisListDirection.visListDirTopToBottom
    Private Const constProcHeader As String = "Processor"
    Private Const constProcMaster As String = "Container 4"

    '
    '
    '
    Public Function buildComponentProcessorContainer _
                        (ByVal intCompKey As Int32, _
                       ByVal _clsData As clsDC_RackData) _
                        As Microsoft.Office.Interop.Visio.Shape

        Dim shpContainer As Microsoft.Office.Interop.Visio.Shape = Nothing

        ' just to make sure
        _clsVisio.drawingPage = drawingPage
        drawingDocument = drawingPage.Document

        Try



            Dim colInput As Collection = New Collection
            Dim drTemp As System.Data.DataRow = Nothing
            Dim processorQuery = From processor In _clsData.m_ds.Tables(DC_RackTables.tblAttrProcessor.ToString).AsEnumerable() _
                       Where processor!physproccompkey = intCompKey
                      Select processor

            ' if empty then get out
            If processorQuery.Count = 0 Then Return shpContainer

            If processorQuery.Count = 1 Then
                For Each p In processorQuery
                    colInput.Add("physProcKey_" & p.Item("physProcKey").ToString)
                    'System.Diagnostics.Debug.WriteLine(p.Item("physProcName").ToString)
                    'System.Diagnostics.Debug.WriteLine(p.Item("physProcKey").ToString)
                    drTemp = p
                Next p
            End If

            ' create a list control
            Dim listControl As Microsoft.Office.Interop.Visio.Shape = Nothing
            Dim colMembers As Collection = New Collection

            ' get our surrogates 
            Dim strStencil As String = ""
            Dim strMaster As String = ""
            Dim strDGMaster As String = ""
            Dim visDG As Microsoft.Office.Interop.Visio.Master = Nothing
            Dim intLabelFont As Integer
            Dim intValueFont As Integer
            Dim dblCalloutWidth As Double
            Dim dgmasterQuery = From datagraphic In _clsData.m_ds.Tables(DC_RackTables.tblDGMasters.ToString).AsEnumerable() _
                                Where datagraphic!dgmTable = DC_RackTables.tblAttrProcessor.ToString _
                                Select datagraphic

            ' should only be one..
            For Each m In dgmasterQuery
                If LCase(m!dgmTable) = LCase(DC_RackTables.tblAttrProcessor.ToString) Then
                    strStencil = m!dgmSurrogateStencil
                    strStencil = _CustomStencilPath & strStencil
                    strMaster = m!dgmSurrogateMaster
                    intLabelFont = CInt(m!dgmFontLabel)
                    intValueFont = CInt(m!dgmFontValue)
                    dblCalloutWidth = CDbl(m!dgmCalloutWidth)
                    strDGMaster = m!dgmMaster
                    Exit For
                End If
            Next

            ' pass in the created collection and return a populated list control
            colMembers = _clsVisio.dropDropDownBoxItems(colInput, strMaster, strStencil, "1.5in", "1in", vbTrue)

            Dim visShape As Microsoft.Office.Interop.Visio.Shape = Nothing
            Dim visCell As Microsoft.Office.Interop.Visio.Cell = Nothing
            Dim strName As String = ""
            Dim strKey As String = ""
            For Each shapeId In colMembers
                ' get the shape
                visShape = drawingPage.Shapes.ItemFromID(shapeId)
                If visShape.CellExists("user.attrkey", False) = True Then
                    strName = visShape.Cells("user.attrkey").ResultStr("")
                Else
                    strName = ""
                    GoTo NextShape
                End If

                ' clear any shape data properties
                _clsVisio.deleteShapeData(visShape)

                ' set it semi-transparent
                Dim strTrans As String = "50%"
                ' first the fill properties
                _clsVisio.recurseApplyCellFormula(visShape, VisSectionIndices.visSectionObject, VisRowIndices.visRowFill, VisCellIndices.visFillForegndTrans, strTrans)
                _clsVisio.recurseApplyCellFormula(visShape, VisSectionIndices.visSectionObject, VisRowIndices.visRowFill, VisCellIndices.visFillBkgndTrans, strTrans)
                ' then the line properties
                _clsVisio.recurseApplyCellFormula(visShape, VisSectionIndices.visSectionObject, VisRowIndices.visRowLine, VisCellIndices.visLineColorTrans, strTrans)
                ' prep it for applying the datagraphics by applying the data from the dgmasters table
                _clsVisio.addDataGraphicUserFieldsToShape _
                        (visShape, _
                        intValueFont.ToString, _
                        intLabelFont.ToString, _
                        dblCalloutWidth.ToString)

                'Check that the requested Data Graphic Master exits
                For Each visMaster In drawingDocument.Masters
                    If visMaster.Type = VisMasterTypes.visTypeDataGraphic Then
                        If visMaster.Name = strDGMaster Then
                            visDG = visMaster
                            Exit For
                        End If
                    End If
                Next
                ' go read the current records
                For Each p In processorQuery
                    strKey = "physProcKey_" & p.Item("physProcKey").ToString
                    If strKey = strName Then
                        UpdateProcessorProperties(visShape, p)
                        visShape.Text = p.Item("physProcName").ToString

                        ' move the name to comment field so we get mouse over
                        If visShape.CellsSRCExists(VisSectionIndices.visSectionObject, VisRowIndices.visRowMisc, VisCellIndices.visComment, False) = True Then
                            visCell = visShape.CellsSRC(VisSectionIndices.visSectionObject, VisRowIndices.visRowMisc, VisCellIndices.visComment)
                            _clsVisio.SetCellValueToString(visCell, strName)
                        End If

                        ' allow the legend to keep track of the shapes
                        _clsVisio.ForceUserProperty(visShape, "visLegendShape", "2.0")

                        'Apply the Data Graphic to the Shape
                        visShape.DataGraphic = visDG

                        ' unlock the groups so we can change the font sizes
                        _clsVisio.recurseApplyCellFormula(visShape, VisSectionIndices.visSectionObject, VisRowIndices.visRowLock, VisCellIndices.visLockGroup, "0")

                        If visShape.CellExists("user.dbIntLabelFont", False) = True Then

                            ' get the loaded values 
                            intLabelFont = CInt(visShape.Cells("user.dbintlabelfont").ResultIU)
                            intValueFont = CInt(visShape.Cells("user.dbintvaluefont").ResultIU)
                            dblCalloutWidth = CDbl(visShape.Cells("user.dbdblcallout").ResultIU)

                            ' set the callout width = 85% of the surrogate shapes width (as a formula) so that it fits inside the shape
                            Dim strId As String = visShape.NameID & "!Width*.85"
                            strId = "Guard(" & strId & ")"

                            _clsVisio.recurseApplyCustomFormula(visShape, "prop.msvcalloutproplabelsize", intLabelFont.ToString & " pt")
                            _clsVisio.recurseApplyCustomFormula(visShape, "prop.msvcalloutpropvaluesize", intValueFont.ToString & " pt")
                            _clsVisio.recurseApplyCustomFormula(visShape, "prop.msvcalloutpropwidth", strId)

                        End If

                        Exit For
                    End If
                Next p
NextShape:
            Next shapeId

            ' add the container to hold the list
            shpContainer = _clsVisio.addContainerToPage(constProcMaster, "contProcessor", "")

            listControl = _clsVisio.loadListControl(colMembers, constProcAlign, constProcDir)
            listControl.Name = "listProc"
            listControl.NameU = "listProc"

            ' add the list control to the container
            _clsVisio.AddShapeToContainer(shpContainer, listControl)

            shpContainer.Cells("pinx").Formula = constProcPinX
            shpContainer.Cells("piny").Formula = constProcPinY


        Catch com As COMException
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(com, "Com+ Policy")
            If (rethrow) Then
                Throw
            End If
        Catch ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

        System.Windows.Forms.Application.DoEvents()
        Return shpContainer

    End Function







#End Region




End Class
