﻿


'*******************************************************************
' Program: Data Center Visio Rack Tool
' Author: Albert E Edlund
' Date:
'
' Purpose:
'
'
'
'*******************************************************************


Imports Microsoft.Practices.EnterpriseLibrary.Common
Imports Microsoft.Practices.EnterpriseLibrary.Data
Imports Microsoft.Practices.EnterpriseLibrary.ExceptionHandling
Imports Microsoft.Practices.EnterpriseLibrary.ExceptionHandling.Logging


Imports System
Imports System.ComponentModel
Imports System.Collections.Generic




Public Class dc_TopoEdge
    Implements INotifyPropertyChanged


#Region "Events"

    Public Event PropertyChanged(ByVal sender As Object, ByVal e As System.ComponentModel.PropertyChangedEventArgs) Implements System.ComponentModel.INotifyPropertyChanged.PropertyChanged

    Private Sub OnPropertyChanged(ByVal info As String)
        RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(info))
    End Sub

#End Region

#Region " Constructor "

    Public Sub New()
        initProperties()
    End Sub


#End Region

#Region " Properties and Fields "


    Public Const constTopoEdgePortDataKey As Int32 = -1
    Public Const constTopoEdgeLinks As String = "[]"
    Public Const constTopoEdgeLinkCt As Integer = 0
    Public Const constTopoEdgeLink As Integer = -1
    Public Const constTopoEdgeBuildDate As Date = #1/1/2001#

    Private m_TopoEdgePortAKey As Int32
    Public Property TopoEdgePortAKey() As Int32
        Get
            Return Me.m_TopoEdgePortAKey
        End Get
        Set(ByVal value As Int32)
            Me.m_TopoEdgePortAKey = value
        End Set
    End Property

    Private m_TopoEdgePortBKey As Int32
    Public Property TopoEdgePortBKey() As Int32
        Get
            Return Me.m_TopoEdgePortBKey
        End Get
        Set(ByVal value As Int32)
            Me.m_TopoEdgePortBKey = value
        End Set
    End Property


    Private m_TopoEdgeLinks As String
    Public Property TopoEdgeLinks() As String
        Get
            Return Me.m_TopoEdgeLinks
        End Get
        Set(ByVal value As String)
            Me.m_TopoEdgeLinks = value
        End Set
    End Property

    Private m_TopoEdgeLinkCt As Int16
    Public Property TopoEdgeLinkCt() As Int16
        Get
            Return Me.m_TopoEdgeLinkCt
        End Get
        Set(ByVal value As Int16)
            Me.m_TopoEdgeLinkCt = value
        End Set
    End Property


    Private m_TopoEdgeLink As Int32
    Public Property TopoEdgeLink() As Int32
        Get
            Return Me.m_TopoEdgeLink
        End Get
        Set(ByVal value As Int32)
            Me.m_TopoEdgeLink = value
        End Set
    End Property

    Private m_TopoEdgeBuildDate As Date
    Public Property TopoEdgeBuildDate() As Date
        Get
            Return Me.m_TopoEdgeBuildDate
        End Get
        Set(ByVal value As Date)
            Me.m_TopoEdgeBuildDate = value
        End Set
    End Property

    Private m_colLinks As Collection
    Public Property _colLinks() As Collection
        Get
            If m_colLinks Is Nothing Then
                m_colLinks = New Collection
            End If
            Return Me.m_colLinks
        End Get
        Set(ByVal value As Collection)
            If m_colLinks Is Nothing Then
                m_colLinks = New Collection
            End If
            m_colLinks = value
        End Set
    End Property





#End Region

#Region " Methods "


    Public Sub initProperties()

        Try

            TopoEdgePortAKey = constTopoEdgePortDataKey
            TopoEdgePortBKey = constTopoEdgePortDataKey
            TopoEdgeLinks = constTopoEdgeLinks
            TopoEdgeLinkCt = constTopoEdgeLinkCt
            TopoEdgeBuildDate = constTopoEdgeBuildDate
            _colLinks = New Collection

        Catch ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

    End Sub


#End Region


End Class


