﻿


'*******************************************************************
' Program: Data Center Visio Rack Tool
' Author: Albert E Edlund
' Date:
'
' Purpose:
'
'
'
'*******************************************************************


Imports Microsoft.Practices.EnterpriseLibrary.Common
Imports Microsoft.Practices.EnterpriseLibrary.Data
Imports Microsoft.Practices.EnterpriseLibrary.ExceptionHandling
Imports Microsoft.Practices.EnterpriseLibrary.ExceptionHandling.Logging


Imports System
Imports System.ComponentModel
Imports System.Collections.Generic




Public Class dc_TopoPoint
    Implements INotifyPropertyChanged


#Region "Events"

    Public Event PropertyChanged(ByVal sender As Object, ByVal e As System.ComponentModel.PropertyChangedEventArgs) Implements System.ComponentModel.INotifyPropertyChanged.PropertyChanged

    Private Sub OnPropertyChanged(ByVal info As String)
        RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(info))
    End Sub

#End Region

#Region " Constructor "

    Public Sub New()
        initProperties()
    End Sub

    Public Sub New(ByVal portKey As Int32)
        initProperties()
        topopointPortDataKey = portKey
    End Sub

#End Region

#Region " Properties and Fields "


    Public Const constTopoPointPortDataKey As Int32 = -1
    Public Const constTopoPointLinks As String = "[]"
    Public Const constTopoPointLinkCt As Integer = 0
    Public Const constTopoPointLink As Integer = -1
    Public Const constTopoPointBuildDate As Date = #1/1/2001#

    Private m_topopointPortDataKey As Int32
    Public Property topopointPortDataKey() As Int32
        Get
            Return Me.m_topopointPortDataKey
        End Get
        Set(ByVal value As Int32)
            Me.m_topopointPortDataKey = value
        End Set
    End Property

    Private m_topopointLinks As String
    Public Property topopointLinks() As String
        Get
            Return Me.m_topopointLinks
        End Get
        Set(ByVal value As String)
            Me.m_topopointLinks = value
        End Set
    End Property

    Private m_topopointLinkCt As Int16
    Public Property topopointLinkCt() As Int16
        Get
            Return Me.m_topopointLinkCt
        End Get
        Set(ByVal value As Int16)
            Me.m_topopointLinkCt = value
        End Set
    End Property


    Private m_topopointLink As Int32
    Public Property topopointLink() As Int32
        Get
            Return Me.m_topopointLink
        End Get
        Set(ByVal value As Int32)
            Me.m_topopointLink = value
        End Set
    End Property

    Private m_topopointBuildDate As Date
    Public Property topopointBuildDate() As Date
        Get
            Return Me.m_topopointBuildDate
        End Get
        Set(ByVal value As Date)
            Me.m_topopointBuildDate = value
        End Set
    End Property

    Private m_colLinks As Collection
    Public Property _colLinks() As Collection
        Get
            If m_colLinks Is Nothing Then
                m_colLinks = New Collection
            End If
            Return Me.m_colLinks
        End Get
        Set(ByVal value As Collection)
            If m_colLinks Is Nothing Then
                m_colLinks = New Collection
            End If
            m_colLinks = value
        End Set
    End Property




#End Region

#Region " Methods "


    Public Sub initProperties()

        Try

            topopointPortDataKey = constTopoPointPortDataKey
            topopointLinks = constTopoPointLinks
            topopointLinkCt = constTopoPointLinkCt
            topopointBuildDate = constTopoPointBuildDate
            _colLinks = New Collection

        Catch ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

    End Sub




#End Region


End Class


